var HyperBKMenuDNDObserver = {

onDragStart: function (aEvent, aXferData, aDragAction)
{
	var target = aEvent.target;
	var x = target.id;
	if (x.indexOf("NC:") != 0) return false; //accept only hyperBK bookmark items (for now)
	
	var dataSet = new TransferDataSet();
	var data    = new TransferData();
	data.addDataForFlavour("hyper/rdfitem", target.id);
	dataSet.push(data);
	aXferData.data = dataSet;
	return true; //can drag
},

onDragOver: function(aEvent, aFlavour, aDragSession) 
{
	var target = aEvent.target;
	var x = aEvent.target.id;
	
	if (target.nodeName != "menu") return;
	
	if (this.mIndex != -1)
	{
		for(var i=0; i<this.mOpenBKMenu.length; i++)
			if (this.mOpenBKMenu[i] == target) return;
		
		for(var i=0; i<this.mOpenBKMenu.length; i++)
		{
			this.mOpenBKMenu[i].childNodes[0].hidePopup();
		}
		
		this.mOpenBKMenu = new Array();
		this.mIndex = -1;
	}
	
	if (target.nodeName == "menu")
	{
		this.mOpenBKMenu[++this.mIndex] = target;
		
		var parN = target.parentNode;
		while (parN.id != "menu_newBookmarksPopup")
		{
			if (parN.nodeName == "menu") 
			{	
				this.mOpenBKMenu[++this.mIndex] = parN;
			}
			parN = parN.parentNode;
		}
		
		
		for(var i=this.mOpenBKMenu.length-1; i>=0; i--)
		{
			this.mOpenBKMenu[i].childNodes[0].showPopup();
		}
		
		
	}
},

onDragEnter: function (aEvent, aDragSession)
{
},

onDragExit: function (aEvent, aDragSession)
{
	
},

onDrop: function (aEvent, aXferData, aDragSession)
{
     var target = aEvent.target;
     this.mOpenBKMenu = new Array();
     this.mIndex = -1;

     try {
	var x = aXferData.data;
	if (x.indexOf("NC:") != 0) return; //accept only hyperBK bookmark items (for now)
	
	var moveBK = Hyper.bookDS.getNode(x);
	var parentnode = HypCommon.BKgetParent(moveBK);
	
	var newparentnode = Hyper.bookDS.getNode(target.id);
	//if (!newparentnode.isContainer())
	//{
		newparentnode = HypCommon.BKgetParent(newparentnode);
	//}
	var newParentNodeID = newparentnode.getValue();
	
	if (newParentNodeID == parentnode.getValue()) //same folder do not move ...should move position
	{
		var bkpos = 0;
		var prp = Hyper.bookDS.getNode(target.id).getInProperties();
		while (prp.hasMoreElements())
		{
			var p = prp.getNext();
			var s = p.getValue();
			var xpos = s.indexOf("http://www.w3.org/1999/02/22-rdf-syntax-ns#_");
			if (xpos >= 0)
			{
				var bkpos = s.substring(44, s.length);
				break;
			}	
		}
		Hyper.dump.logStringMessage("Move BK Change Index " + bkpos);
		parentnode.removeChild(moveBK);
		parentnode.addChildAt(moveBK, bkpos);
		return;
	}
	
	parentnode.removeChild(moveBK);
	newparentnode.addChild(moveBK, false);
	
	if (moveBK.isContainer()) //HISTORY
	{
		try {
			var histNode = Hyper.histDS.getNode(x);
			var histParent = HypCommon.BKgetParent(histNode);
			var newHistParent = Hyper.histDS.getNode(newParentNodeID);
		
			histParent.removeChild(histNode);
			newHistParent.addChild(histNode, false);
		}
		catch (err)
		{
			Hyper.dump.logStringMessage("error " + err);
		}
	}
	
	Hyper.dump.logStringMessage("Bookmark Menu Move " +aXferData.data + ", target " + newParentNodeID);
    }
    catch (err)
    {
    	Hyper.dump.logStringMessage("Move Error " + err);
    }
},

canDrop: function (aEvent, aDragSession)
{
	if (aEvent.target.nodeName == "menu")
		return true;
	else if (aEvent.target.nodeName == "menuitem")
		return true;
	else 
		return false;
},

canHandleMultipleItems: false,

getSupportedFlavours: function () 
{
	var flavourSet = new FlavourSet();
    	flavourSet.appendFlavour("hyper/rdfitem");
    	return flavourSet;
},


//Private Members

mOpenBKMenu : new Array(),
mIndex : -1,
mtest : "hello"



}