//SIDEBAR DRAGGING ....
var HyperBKSBDNDObserver = {

onDragStart: function (aEvent, aXferData, aDragAction)
{
	try{		
		var bktree = window.document.getElementById("bktree");
		var i = bktree.view.selection.currentIndex;
		if (i == -1) return false;
		
		//Hyper.dump.logStringMessage("x start "+aEvent.pageX);
		//Hyper.dump.logStringMessage("tree width " + bktree.treeBoxObject.width);

		if (aEvent.pageX >= bktree.treeBoxObject.width-20) return false; //cannot move because outside bounds

		var x = bktree.view.getResourceAtIndex(i).Value;

		if (x.indexOf("NC:") != 0) return false; //accept only hyperBK bookmark items (for now)

		var dataSet = new TransferDataSet();
		var datat   = new TransferData();
		datat.addDataForFlavour("hyper/rdfitem", x);
		dataSet.push(datat);
		aXferData.data = dataSet;

		Hyper.dump.logStringMessage("drag start "+x);
	}
	catch (err)
	{
		Hyper.dump.logStringMessage(err);
		return false;
	}
	
	return true; //can drag
},

onDragOver: function(aEvent, aFlavour, aDragSession) 
{
	//for (var s in aFlavour) Hyper.dump.logStringMessage(s);
	if (aFlavour.contentType != "hyper/rdfitem") 
	{
		aDragSession.canDrop = false;
		return false;
	}
	
	//Hyper.dump.logStringMessage(aFlavour.contentType);
	aDragSession.canDrop = true;
	return true;
},

onDragEnter: function (aEvent, aDragSession)
{
	return true;
},

onDragExit: function (aEvent, aDragSession)
{
	return true;
},

onDrop: function (aEvent, aXferData, aDragSession)
{
	//onDrop never called
},

canDrop: function (aEvent, aDragSession)
{
	if (aEvent.target.nodeName == "treechildren")
		return true;
	else if (aEvent.target.nodeName == "treeitem")
		return true;
	else if (aEvent.target.nodeName == "treerow")
		return true;
	else if (aEvent.target.nodeName == "treecell")
		return true;
	else 
		return false;
},

canHandleMultipleItems: false,

getSupportedFlavours: function () 
{
	var flavourSet = new FlavourSet();
    	flavourSet.appendFlavour("hyper/rdfitem");
    	return flavourSet;
},


//Private Members


mtest : "hello",

RDFService : Components.classes["@mozilla.org/rdf/rdf-service;1"].getService().QueryInterface(Components.interfaces.nsIRDFService),




}


function SBgetNode(event, tree)
{
	var row = new Array();
	var col = new Array();
	var child = new Array();
	tree.treeBoxObject.getCellAt(event.pageX, event.pageY, row, col, child);
	var tNode = null;

	if (row.value == -1) 
	{
		tNode = "NC:BookmarksRoot";	
	}
	else
	{
		tNode = bktree.view.getResourceAtIndex(row.value).Value;
	}
	
	return tNode;
}

function SBonDrop(event)
{
	try {
	//Hyper.dump.logStringMessage("drop");
	var bktree = window.document.getElementById("bktree");

	var i = bktree.view.selection.currentIndex;
	if (i == -1) return false;
	//var x = bktree.view.getItemAtIndex(i).id;
	var x = bktree.view.getResourceAtIndex(i).Value;

	var tNode = SBgetNode(event, bktree)
	if ((tNode == null) || (tNode.indexOf("NC:") != 0))
	{
		alert("Move Failed");
		return false;
	}
	
	//Hyper.dump.logStringMessage(x  + " to " + tNode.id);
	
	var movebk = Hyper.bookDS.getNode(x);
	var oldparent = HypCommon.BKgetParent(movebk);
	var targetbk = Hyper.bookDS.getNode(tNode);
	
	if (!targetbk.isContainer()) targetbk = HypCommon.BKgetParent(targetbk);
	
	if (targetbk == null) 
	{
		Hyper.dump.logStringMessage("move error...");
		return false;
	}
	
	if (oldparent.getValue() == targetbk.getValue()) return false; //nothing moved
	if (targetbk.getValue() == movebk.getValue()) return false; //we have big problems
	
	oldparent.removeChild(movebk);
	targetbk.addChild(movebk, false);
     	
     	var newParentNodeID = targetbk.getValue();
     	if (movebk.isContainer()) //history
     	{
     		try {
			var histNode = Hyper.histDS.getNode(x);
			var histParent = HypCommon.BKgetParent(histNode);
			var newHistParent = Hyper.histDS.getNode(newParentNodeID);
			
			histParent.removeChild(histNode);
			newHistParent.addChild(histNode, false);
		}
		catch (err)
		{
			Hyper.dump.logStringMessage("error " + err);
		}
     	}
     	
     	}
     	catch (err)
     	{
     		Hyper.dump.logStringMessage(err);
     	}
     	
     	return true;
}