
var ftree;
var bklist;
var bookDS;
var histDS;
var Hyper;
var toregen = false;

function Startup()
{
	Hyper = window.arguments[0];
	bookDS = Hyper.bookDS;
	histDS = Hyper.histDS;
	
	ftree = document.getElementById("ftree");
	ftree.database.AddDataSource(bookDS.getRawDataSource());
	ftree.builder.rebuild();
	ftree.addEventListener("click", onFolderSelect , true);

	bklist = document.getElementById("bklist");
	bklist.database.AddDataSource(bookDS.getRawDataSource());
	bklist.builder.rebuild();
	
}

function onFolderSelect()
{
	var i = -1;
	if (ftree.view != null) //in case of newly created bookmark file
		i = ftree.view.selection.currentIndex;
	var nname
	if (i == -1)
		nname = "NC:BookmarksRoot";
	else
		nname = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id; //folder name ...?
	
	bklist.setAttribute("ref", nname);
	
}

function openLink()
{
	Hyper.OpenBK(bklist.getItemAtIndex(bklist.selectedIndex).id, true);
}

function openLinkCache()
{
	Hyper.OpenBKCache(bklist.getItemAtIndex(bklist.selectedIndex).id, true);
}

function openSEReferrer()
{
	var nd = Hyper.bookDS.getNode(bklist.getItemAtIndex(bklist.selectedIndex).id);
	var ref = nd.getTarget("http://home.netscape.com/NC-rdf#Referrer");
	if (ref == null) alert(HypCommon.getString("NO_SE_REF"));
	else Hyper.openNewTab(ref.getValue());
}


///Toolbar Functionality

function selectedComp() //need to detect which component is selected ..either tree or richlistbox
{
	var cx = document.commandDispatcher.focusedElement;
	if ((cx.nodeName == "image") || (cx.nodeName == "richlistitem") || (cx.nodeName == "label"))
	{
		bklist.ensureSelectedElementIsVisible();
		return "bklist"	
	}
	else if (cx.nodeName == "tree")
	{
		return "tree"
	}
	else if (cx.nodeName == "richlistbox")
	{
		if (bklist.selectedIndex >= 0) return "bklist";
	}
	else alert(HypCommon.getString("PLS_SEL_SOMETHING"));
	
	return "";
}

function NewFolder()
{
	window.openDialog("chrome://hyper/content/hyperFolder.xul", "" , "centerscreen,chrome,dialog=yes,resizable=yes,modal=yes", bookDS, Hyper.histDS, "");
}

function DelBookmark()
{
	toregen = true; //to regenerate keywords on finish
	var sc = selectedComp();
	var scname = "";
	if (sc == "bklist")
	{
		bklist.ensureSelectedElementIsVisible();
		sc = bklist.getItemAtIndex(bklist.selectedIndex).id;
		scname = bklist.getItemAtIndex(bklist.selectedIndex).value;
	}
	else if (sc == "tree")
	{
		var i = ftree.view.selection.currentIndex;
		sc = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id;
		scname = "Folder: " + sc.substring(3,sc.length);///.......
	}
	if (sc == "") return;
	
	if (!confirm(HypCommon.getString("SURE_DELBK")+"\r\n" + scname)) return;
	HypCommon.BKDelete(sc, bookDS, histDS);
	
	bookDS.save();
}

function RenameBookmark()
{
	var sc = selectedComp();
	if (sc == "bklist")
	{
		bklist.ensureSelectedElementIsVisible();
		sc = bklist.getItemAtIndex(bklist.selectedIndex).id;
	}
	else if (sc == "tree")
	{
		var i = ftree.view.selection.currentIndex;
		sc = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id;
	}
	if (sc == "") return;
	
	HypCommon.BKRename(sc, bookDS, histDS);
	
	bookDS.save();
}

function MoveBookmark()
{
	toregen = true; //to regenerate keywords on finish
	var sc = selectedComp();
	if (sc == "bklist")
	{
		bklist.ensureSelectedElementIsVisible();
		sc = bklist.getItemAtIndex(bklist.selectedIndex).id;	
	}
	else if (sc == "tree")
	{
		var i = ftree.view.selection.currentIndex;
		sc = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id;
	}
	if (sc == "") return;
	
	var result = new Object();
	window.openDialog("chrome://hyper/content/hyperSelectFolder.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable", Hyper, result);
	if (result.res == null) 
	{ 
		alert(HypCommon.getString("NOTHING_MOVED")); 
		return; 
	}
	var nname = result.res;
	newparentnode = bookDS.getNode(nname);
	
	var movenode = bookDS.getNode(sc); //sc is a string which contains the uri to the node
			
	var parentnode = HypCommon.BKgetParent(movenode);
	
	parentnode.removeChild(movenode);
	newparentnode.addChild(movenode);
	
	if (movenode.isContainer()) //history
	{
	    try {
		var hmovenode = histDS.getNode(sc);
		var hnewparnode = histDS.getNode(nname);
		var holdpar = HypCommon.BKgetParent(hmovenode);
		
		holdpar.removeChild(hmovenode);
		hnewparnode.addChild(hmovenode, false);
	    } catch (err) {}
	}
	
	bookDS.save();
}

function MoveUpDown(k)
{
	var sc = selectedComp();
	if (sc == "bklist")
	{
		bklist.ensureSelectedElementIsVisible();
		sc = bklist.getItemAtIndex(bklist.selectedIndex).id;	
	}
	else if (sc == "tree")
	{
		var i = ftree.view.selection.currentIndex;
		sc = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id;
	}
	if (sc == "") return;
	
	HypCommon.BKUpDown(sc, k, bookDS, histDS);
	
	ftree.builder.rebuild();
	
	bookDS.save();
}

function Export()
{
	window.openDialog("chrome://hyper/content/hyperBKExport.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,height=500,width=600", bookDS);
}

function Import()
{
	Hyper.ImportBK();
}

function Sort()
{
	HypCommon.BKSort(bookDS);
	if (confirm(HypCommon.getString("SORT_HISTORY"))) HypCommon.BKSort(histDS);
}

function RepairDS()
{
	Hyper.RepairDS();
}

function Finish()
{
	if (toregen) 
	{
		Hyper.regenBF();
		Hyper.LoadURLs();
	}
}