
var ftree;
var bookDS;
var histDS;
var Hyper = null;
var tempDS = null;
var Amain = true;
var filtb = null;
var fillb = null;
var toregen = false;


function Startup()
{
	Hyper = window.arguments[0];
	bookDS = Hyper.bookDS;
	histDS = Hyper.histDS;
	
	ftree = document.getElementById("hybmtreelist");
	ftree.database.AddDataSource(bookDS.getRawDataSource());
	ftree.builder.rebuild();
	
	ftree.addEventListener("dblclick", linkDBClick, true);
	filtb = document.getElementById("filterval");
	fillb = document.getElementById("filtertyp");
	
	//var rt = document.getElementById("NC:BookmarksRoot");
	//rt.setAttribute("open", "true"); //uncollapse root
}

function Finish()
{
	if (toregen)
	{
		Hyper.regenBF();
		Hyper.LoadURLs();
	}
}

function getSelected(noalert) //returns array with selected indeces
{
	var arr = new Array();
	var st = new Object();
	var ed = new Object();
	var numRanges = ftree.view.selection.getRangeCount();
	var j = 0;
	
	if (numRanges == 0)
	{
		if (noalert == true) return arr;
		
		alert(HypCommon.getString("PLS_SEL_SOMETHING"));
		return arr;
	}
	
	for (var t=0; t<numRanges; t++)
	{
	  ftree.view.selection.getRangeAt(t,st,ed);
	  for (var v=st.value; v<=ed.value; v++)
	  {
	   	arr[j] = v;
	   	j++;
	  }
	}

	return arr;
}

function DelBookmark()
{	
	toregen = true; //to regenerate keywords on finish
	var arr = getSelected(); //todo show warning on multi delete
	var delnode;
	var s = new Array();
	
	if (arr.length > 1) //multi delete
	{
		if (!confirm(HypCommon.getString("SURE_DEL_BKS"))) return;
	}
	else if (arr.length == 1) //in case of 1 selection
	{
		var msg = HypCommon.getString("SURE_DELBK");
		if (ftree.view.isContainer(arr[0])) msg = HypCommon.getString("DEL_BKANDBKS");
		if (!confirm(msg)) return;
	}
	else return; //in case of no selection
	
	//first get list of bookmarks/folders to delete
	for (var j=0; j<arr.length; j++) s[j] = ftree.view.getResourceAtIndex(arr[j]).Value; //.getItemAtIndex(arr[j]).id; //folder name
	
	//then delete
	for (var j=0; j<s.length; j++) HypCommon.BKDelete(s[j], bookDS, histDS);
	
	bookDS.save();
}

function RenameBookmark()
{
	var arr = getSelected();
	var s;
	
	if (arr.length == 0)
	{
		return;
	}
	if (arr.length > 1)
	{
		alert(HypCommon.getString("PLS_SEL_1EML"));
		return;
	}
	
	//s = ftree.view.getItemAtIndex(arr[0]).id; //folder name ...?
	s = ftree.view.getResourceAtIndex(arr[0]).Value;
	HypCommon.BKRename(s, bookDS, histDS);
	bookDS.save();
}

function MoveBookmark()
{
	toregen = true; //to regenerate keywords on finish
	var arr = getSelected();
	var s = new Array();
	var newparentnode; //need to do ....select folder
	
	if (arr.length <= 0) return;
	
	var result = new Object();
	window.openDialog("chrome://hyper/content/hyperSelectFolder.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable", Hyper, result);
	if (result.res == null) 
	{ 
		alert(HypCommon.getString("NOTHING_MOVED")); 
		return; 
	}
	var nname = result.res;
	newparentnode = bookDS.getNode(nname);
	
	//get list of names to move
	for (var j=0; j<arr.length; j++) //s[j] = ftree.view.getItemAtIndex(arr[j]).id;
	s[j] = ftree.view.getResourceAtIndex(arr[j]).Value;
	
	for (var j=0; j<s.length; j++)
	{
		var movenode = bookDS.getNode(s[j]); //s is a string which contains the uri to the node
		
		var parentnode = HypCommon.BKgetParent(movenode);
		parentnode.removeChild(movenode);
		newparentnode.addChild(movenode);
		
		if (movenode.isContainer()) //move history too
		{
		   try {
			var hmovenode = histDS.getNode(s[j]);
			var hparnode = HypCommon.BKgetParent(hmovenode);
			var hnewpar = histDS.getNode(nname);
			
			hparnode.removeChild(hmovenode);
			hnewpar.addChild(hmovenode);
		   } catch (err) {}
		}
	}
	bookDS.save();
}

function NewFolder()
{
	window.openDialog("chrome://hyper/content/hyperFolder.xul", "" , "centerscreen,chrome,dialog=yes,resizable=yes,modal=yes", bookDS, Hyper.histDS, "");
}

function MoveUpDown(k)
{
	var arr = getSelected();
	
	if (arr.length <= 0) return;
	if (arr.length > 1)
	{
		alert(HypCommon.getString("SEL_ONLY_ONEBK"));
		return;
	}
	
	//var s = ftree.view.getItemAtIndex(arr[0]).id;
	var s = ftree.view.getResourceAtIndex(arr[0]).Value;
	
	HypCommon.BKUpDown(s, k, bookDS, histDS);
	
	ftree.builder.rebuild();
	
	//bookDS.save();
}

function Export()
{
	window.openDialog("chrome://hyper/content/hyperBKExport.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,height=500,width=600", bookDS);
}

function Import()
{
	Hyper.ImportBK();
}

function Sort()
{
	HypCommon.BKSort(bookDS);
	if (confirm(HypCommon.getString("SORT_HISTORY"))) HypCommon.BKSort(histDS);
}

function RepairDS()
{
	Hyper.RepairDS();
}

function linkDBClick(e) //open selected bookmark by double click
{
	var arr = getSelected(true);
	if (arr.length < 0) return;
	
	if (ftree.view.isContainer(arr[0])) return;
	
	var s = ftree.view.getResourceAtIndex(arr[0]).Value;
	Hyper.OpenBK(s, true);
}

function openSER()
{
	var arr = getSelected();
	if (arr.length < 0) return;
		
	if (ftree.view.isContainer(arr[0])) return;
		
	var s = ftree.view.getResourceAtIndex(arr[0]).Value;
	var nd = bookDS.getNode(s);
	var ref = nd.getTarget("http://home.netscape.com/NC-rdf#Referrer");
	if (ref == null) alert(HypCommon.getString("NO_SE_REF"));
	else Hyper.openNewTab(ref.getValue());
}

function expcol(ec)
{
	for(var i=ftree.view.rowCount-1; i>=0; i--)
	{
		if (ftree.view.isContainer(i))
		if (ftree.view.isContainerOpen(i) == !ec) ftree.view.toggleOpenState(i);
	}
}

////////////////
function genDates()
{
	var s = "";
	var ddate = new Date();
	ddate.setDate(ddate.getDate()-20);
	for (var i=0; i<21; i++)
	{
		ddate.setDate(ddate.getDate()+1);
		var month = ddate.getMonth() + 1;
		s = ddate.getDate() + '|' + month + '|' + ddate.getFullYear();
		filtb.appendItem(s, s, "");
	}
}

function genVCounts()
{
	for (var i=0; i<50; i=i+5)
	{
		filtb.appendItem(i, i, "");
	}
}

function afilter(s)
{
	filtb.removeAllItems();
	filtb.value = "";
	switch (s)
	{
		case "none" : fillb.value = HypCommon.getString("K_NONE"); break;
		case "vc" : fillb.value = HypCommon.getString("K_VISIT COUNT"); genVCounts(); break;
		case "rv" : fillb.value = HypCommon.getString("K_RARELY VISITED"); break;
		case "kw" : fillb.value = HypCommon.getString("K_KEYWORD"); break;
		case "dt" : fillb.value = HypCommon.getString("K_DATE"); genDates(); break;
	}
}

function apfilter()
{
	var s = fillb.value;
	if (Amain == false)
		ftree.database.RemoveDataSource(tempDS.getRawDataSource());
	else
		ftree.database.RemoveDataSource(bookDS.getRawDataSource());
	
	switch (s)
	{
		case "None" : {
			ftree.database.AddDataSource(bookDS.getRawDataSource());
			Amain = true;
			break;
		}
		case "Visit Count" : {
			//tempDS = new RDFDataSource();
			
			filterVC(filtb.value);
			
			ftree.database.AddDataSource(tempDS.getRawDataSource());
			Amain = false;
			break;
		}
		case "Rarely Visited" : {///not working
			tempDS = new RDFDataSource();
			
			ftree.database.AddDataSource(tempDS.getRawDataSource());
			Amain = false;
			break;
		}
		case "Keyword" : {
			//tempDS = new RDFDataSource();
					
			filterKW(filtb.value);
					
			ftree.database.AddDataSource(tempDS.getRawDataSource());
			Amain = false;
			break;
		}
		case "Date" : {
			filterDt(filtb.value);
			ftree.database.AddDataSource(tempDS.getRawDataSource());
			Amain = false;
			break;
		}
	}
	ftree.builder.rebuild();
}

function filterVC(maxk)
{
	tempDS = new RDFDataSource();
	bookDS.copyAllToDataSource(tempDS);
	var nodes = tempDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var bk = nodes.getNext();
		if (!bk.isContainer())
		{
			var svc = bk.getTarget("http://home.netscape.com/NC-rdf#VisitCount");
			svc = parseInt(svc.getValue());
			if (svc < maxk)
				tempDS.deleteRecursive(bk);
		}
	}
}

function filterKW(kw)
{
	kw = kw.toLowerCase();
	tempDS = new RDFDataSource();
	bookDS.copyAllToDataSource(tempDS);
	var nodes = tempDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var bk = nodes.getNext();
		if (!bk.isContainer())
		{
		   try {
			var bName = bk.getTarget("http://home.netscape.com/NC-rdf#Name");
			var bURL = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
			var bKeywords = bk.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
			var bTitle = bk.getTarget("http://home.netscape.com/NC-rdf#Page");
			var s = bName.getValue() + " " + bURL.getValue() + " " + bKeywords.getValue() + " " + bTitle.getValue();
			s = s.toLowerCase();
			if (HypCommon.searchMatch(kw, s) < 0)
				tempDS.deleteRecursive(bk);
		   } catch (err) {}
		}
	}
}

function filterDt(date)
{
	date = HypCommon.BKdateNormalize(date);
	tempDS = new RDFDataSource();
	bookDS.copyAllToDataSource(tempDS);
	var nodes = tempDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var bk = nodes.getNext();
		if (!bk.isContainer())
		{
			var dt = bk.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
			var dn = HypCommon.BKdateNormalize(dt.getValue());
			if (!(dn == date))
			{
				tempDS.deleteRecursive(bk);
			}
		}
	}
}

