////////////////////////////////////////////////////////////////////
///Functions Common for HyperBK extension
///
///Ian Bugeja 2006
///B.Sc. I.T. (Hons.)
///University of Malta - Department of Computer Science and A.I.
///

var HypCommon = new Object();

HypCommon.userHome = function(foldern, filen) //Get path to user local profile directory *platorm independent
{
	var path;
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert(HypCommon.getString("ERROR_PERMISSION_FILE"));
	} // get the path to the user's home (profile) directory
	const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
	try {
		path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
	} catch (e) {
		alert(HypCommon.getString("ERROR_USERPROFILE"));
	} 
	
	var forflag = false;
	if (path.search(/\\/) != -1) forflag = true; // determine the file-separator
		
	if (foldern != "")
	{
		if (forflag) path = path + "\\" + foldern; else path = path + "/" + foldern;
	}
		
	if (filen != "")
	{
		if (forflag) path = path + "\\" + filen; else path = path + "/" + filen;
	}
	
	return path;
}

HypCommon.randomString = function() //returns a random string length 8
{
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
	var string_length = 8;
	var randomstring = "";
	for (var i=0; i<string_length; i++) 
	{
		var rnum = Math.floor(Math.random() * chars.length);
		randomstring += chars.substring(rnum,rnum+1);
	}
	return randomstring;
}

HypCommon.getKeylist = function(rtf, x) //convert keyword array to semicolon delimited string
{
	var s = "";
	if ((rtf == null) || (rtf.length <= 0)) return "";
	
	for(var i=0; i<rtf.length; i++)
	{
		s = s + rtf[i][x] + ";";
	}
	return s;
}

HypCommon.searchMatch = function(ss, s) //ss=string to search, s=whole string ...supports searching of multiple keywords
{
	var sarr = ss.split(" ");
	
	var found = 0;
	for (var i=0; i<sarr.length; i++)
	{
		if (s.indexOf(sarr[i]) >= 0) found++;
	}
	if (found >= sarr.length) return 1; else return -1;
}

HypCommon.reduceBookmarkName = function(bkname) //returns reduced bookmark name (if possible)
{
	var dash = bkname.indexOf("-");
	if (dash == -1) dash = bkname.indexOf("|");
	if (dash == -1) dash = bkname.indexOf(":");
	if (dash == -1) dash = bkname.indexOf(",");
	if (dash == -1) dash = bkname.indexOf("(");
	
	if ((dash != -1) && (dash > 5)) //found dash and at least 5 characters in front
	{
		return bkname.slice(0, dash);
	}
	
	var bklower = bkname.toLowerCase();
	var welcome = bklower.indexOf("welcome");
	if (welcome != -1)
	{
		var to = bklower.indexOf("to");
		if (to != -1)
		{
			return bkname.slice(to+2);
		}
		else
		{
			return bkname.slice(welcome+7);
		}
	}
	
	return bkname; //nothing done thus return full bk
}

HypCommon.getSCon = function(aurl) //read script from file and returns it as string
{
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);
	var channel = ioService.newChannel(aurl, null, null);
	var input = channel.open();
	scriptableStream.init(input);
	var str = scriptableStream.read(input.available());
	scriptableStream.close();
	input.close();
	return str;
}

HypCommon.saveHTMLCache = function(Hyp, htmldoc, cachepath)
{
	if (cachepath == null) cachepath = this.randomString();
	Hyp.SaveDoc(htmldoc, cachepath);
	
	return cachepath;
}

HypCommon.updateHTMLCache = function(Hyp, htmldoc, bookmark) //problem that thumb might not have been drawn yet....
{
	var cachep = bookmark.getTarget("http://home.netscape.com/NC-rdf#ShortcutURL");
	this.BKDelCache(null, cachep);
	
	var cachepath = this.randomString();
	Hyp.SaveDoc(htmldoc, cachepath);
	var cpath = "file://" + this.userHome("hyperCache", cachepath+".html");
	cpath = cpath.replace(/\s/g, "%20");
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#ShortcutURL", cpath);
}

HypCommon.drawThumbnail = function(mywin, canvas)
{
	var canvasW = 100;
	var canvasH = 100;
	var w = mywin.innerWidth;
	var h = mywin.innerHeight;
	
	canvas.style.width = canvasW+"px";
	canvas.style.height = canvasH+"px";
	canvas.width = canvasW;
	canvas.height = canvasH;
	
	var ctx = canvas.getContext("2d");
	ctx.clearRect(0, 0, canvasW, canvasH);
	ctx.save();
	ctx.scale(canvasW/w, canvasH/h);
	ctx.drawWindow(mywin, mywin.scrollX, mywin.scrollY, w, h, "rgb(255,255,255)");
	ctx.save();
   	ctx.restore();
}

HypCommon.GetInputStreamOfCanvasData = function(aImageCanvas) //from extension of pearl crescent
{
  try {                
    var s = aImageCanvas.toDataURL();  // TODO: options like transparency=none?
    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
    var uriObj = ioService.newURI(s, null, null);
    var dataChannel = ioService.newChannelFromURI(uriObj);
    var binStream = Components.classes["@mozilla.org/binaryinputstream;1"]
                  .createInstance(Components.interfaces.nsIBinaryInputStream);
    var inputstream = dataChannel.open();
    binStream.setInputStream(inputstream);
    return binStream;
  } catch(e) {}

  return null;
}


HypCommon.SaveThumbImage = function(aImageCanvas, aSaveLoc) //adapted from extension of pearl crescent
{
	var succeeded = false;
      	var binStream = this.GetInputStreamOfCanvasData(aImageCanvas);
      	if (binStream) ///Firefox 2.0
      	{
      		try
        	{
          		const kFileStreamClass = "@mozilla.org/network/file-output-stream;1";
          		var fileStream = Components.classes[kFileStreamClass]
          	              .createInstance(Components.interfaces.nsIFileOutputStream);
          		const kWriteOnly = 0x02; // see prio.h
          		const kCreateFile = 0x08;
          		const kTruncate = 0x20;
          		var flags = kWriteOnly | kCreateFile | kTruncate;
          		fileStream.init(aSaveLoc, flags, 0666, false);
    
    			const kMaxBlockSize = 65536;
          		var remaining = binStream.available();
          		while (remaining > 0)
          		{
          			var toRead = (remaining > kMaxBlockSize) ? kMaxBlockSize : remaining;
            			var data = binStream.readBytes(toRead);
            			fileStream.write(data, toRead);
            			remaining -= toRead;
          		}
          		//PearlCopyStreamToStream(binStream, fileStream);
          		fileStream.close();
        
        		succeeded = true;
        	}
        	catch(e) { alert(e); }
      	}
	else //FIREFOX 1.5
	{
    		try
    		{
    			const contractid = "@pearlcrescent.com/canvas2png;1";
    			var clazz = Components.classes[contractid];
    			if (!clazz)
    			{
      				alert("Component not found " + contractid);
      				return;
    			}

    			var obj = clazz.createInstance(); 
    			if (obj) obj = obj.QueryInterface(Components.interfaces.pcICanvas2PNG);
    			if (obj)
    			{
      				obj.init(aImageCanvas);

      				if (aSaveLoc)
      				{
        				obj.saveAsPNG(aSaveLoc);
      				}
    			}
    			else alert("ERROR_CLASSNOTFOUND");
     		}
     		catch(e) { /*alert(e);*/ }
     	}
}

HypCommon.saveThumbFile = function(fname, canvas)
{
	var filep = this.userHome("hyperBKIC", fname + ".png");
   	var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
   	localFile.initWithPath(filep);

   	this.SaveThumbImage(canvas, localFile);
   	
   	return filep;
}

HypCommon.updateThumbFile = function(htmldoc, bookmark)
{
	var canvas = htmldoc.getElementById("hyperthumb");
	var cachefp = bookmark.getTarget("http://home.netscape.com/NC-rdf#Image");
	if (cachefp != null) this.BKDelCache(cachefp, null);
	
	var fname = this.randomString();
	var fp = this.saveThumbFile(fname, canvas);
	fp = "file://" + fp.replace(/\s/g, "%20");
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Image", fp);
}

HypCommon.tempShowThumb = function(htmldoc, showflg)
{
	var canvas = htmldoc.getElementById("hyperthumb");
	var iframe = htmldoc.getElementById("hyperdiv");
	
	if (showflg)
	{
		canvas.style.display = "inline"; // temporarily show the canvas.
		iframe.style.display = "inline"; // temporarily show the canvas.
	}
	else //hide
	{
		canvas.style.display = "";
		iframe.style.display = "";
	}
}

HypCommon.delayISave = function(htmldoc, cachepath) //delayed saving of thumbnail *not used**
{
	var canvas = htmldoc.getElementById("hyperthumb"); //get canvas from page
	this.saveThumbFile(cachepath, canvas);
	this.tempShowThumb(htmldoc, false);
}

/////////////////////////////////////////////////////////////////////////////
////Date Routines - to String, to Int, to JS Date

HypCommon.sDateConv = function(st) //string to Date conversion
{
	if (st == null) return new Date();
	if (st.indexOf("|") < 0) return new Date();
	
	var bkd = st.substr(0, st.indexOf("|"));
	var bkm = st.substr(st.indexOf("|")+1, st.lastIndexOf("|")-1-st.indexOf("|"));
	var bky = st.substr(st.lastIndexOf("|")+1, 4);
	bkm = parseInt(bkm)-1;
	
	var ic = st.indexOf(":");
	if (ic != -1)
	{
		var hou = st.substring(st.indexOf(" ")+1, ic);
		var mins = st.substring(ic+1, st.length);
		var ddate = new Date(bky, bkm, bkd, hou, mins, "0");
	}
	else
		var ddate = new Date(bky, bkm, bkd);
	
	return ddate;
}

HypCommon.BKdateNormalize = function(st, year) //returns date in integer year-month-day (and time)
{
	var bkd = st.substr(0, st.indexOf("|"));
	if (bkd.length == 1) bkd = "0" + bkd;
	var bkm = st.substr(st.indexOf("|")+1, st.lastIndexOf("|")-1-st.indexOf("|"));
	if (bkm.length == 1) bkm = "0"+bkm;
	var bky = st.substr(st.lastIndexOf("|")+1, 4);
	
	if ((year == false) || (year == null))
	{
	   var ic = st.indexOf(":");
	   if (ic != -1)
	   {
		var hou = st.substring(st.indexOf(" ")+1, ic);
		if (hou.length == 1) hou = "0" + hou;
		var mins = st.substring(ic+1, st.length);
		
		return parseFloat(bky+bkm+bkd+"."+hou+mins); //not to overflow
	   }
	}
	
	return parseInt(bky+bkm+bkd);
}

HypCommon.dateToStr = function(date, t) ///t = true if date must have time
{
	var s = "";
	var month = date.getMonth() + 1;
	var minutes = (date.getMinutes().toString().length > 1) ? date.getMinutes() : "0" + date.getMinutes();
	if (t)
		s = date.getDate() + '|' + month + '|' + date.getFullYear() + ' ' + date.getHours() + ':' + minutes;
	else
		s = date.getDate() + '|' + month + '|' + date.getFullYear();
		
	return s;
}
///////////////////////

//bkfunc
HypCommon.BKgetParent = function(node) //get parent of bookmark (RDF Node)
{
	var parentnode = null;
	var prp = node.getInProperties();
	while (prp.hasMoreElements())
	{
		var p = prp.getNext();
		var s = p.getValue();
		if (s.indexOf("http://www.w3.org/1999/02/22-rdf-syntax-ns#_") >= 0) 
		{
			parentnode = node.getSource(s);
			break;
		}
	}
	return parentnode;
}

HypCommon.BKDelete = function(s, bookDS, histDS) //recursive
{
	var delnode = bookDS.getNode(s);
	var cachep = delnode.getTarget("http://home.netscape.com/NC-rdf#ShortcutURL");
	var cachefp = delnode.getTarget("http://home.netscape.com/NC-rdf#Image");
	
	if (!delnode.isContainer()) //if bookmark to delete is not container then del thumbnail and cache
	{
		this.BKDelCache(cachefp, cachep);
	}
	else //if container then must remove all children
	{
		try
		{
			var hdelnode = histDS.getNode(s); //if container than must also remove from history
			histDS.deleteRecursive(hdelnode);//children inside will be left and deleted when history expires
		} catch (err) {}
		
		var chil = delnode.getChildren();
		while (chil.hasMoreElements())
		{
			var bk = chil.getNext();
			this.BKDelete(bk.getValue(), bookDS, histDS);
		}
	}
	
	bookDS.deleteRecursive(delnode); //delete from bookmark datasource
}

HypCommon.BKDelCache = function(cachefp, cachep) //image, html
{
	var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	if (cachefp != null)
	{
	   try
	   {    //Remove Page Thumbnail
		var imagep = cachefp.getValue();
		imagep = imagep.substring(7, imagep.length);
		imagep = imagep.replace(/\%20/g, " ");
		localFile.initWithPath(imagep);
		localFile.remove(true);
	   }
	   catch (err) {  }
	}
	
	if (cachep != null)
	{
	   try
	   {	//Remove HTML from cache
		var filep = cachep.getValue();
		filep = filep.substring(7, filep.length);
		filep = filep.replace(/\%20/g, " ");
		localFile.initWithPath(filep); //need to remove file:// and %20
		localFile.remove(true);
		var filep = filep.substring(0, filep.length-5) + "_data";
		localFile.initWithPath(filep);
		localFile.remove(true);
	   }
	   catch (err) {  }
	}
}

HypCommon.BKRename = function(s, bookDS, histDS) //rename bookmark
{
	var renamenode = bookDS.getNode(s);
		
	var st = renamenode.getTarget("http://home.netscape.com/NC-rdf#Name");
	var newval = prompt(HypCommon.getString("RENAME_BK"), st.getValue());
	
	if ((newval == null) || (newval == "") || (newval == st.getValue())) return;
	
	renamenode.addTargetOnce("http://home.netscape.com/NC-rdf#Name", newval);
	
	if (renamenode.isContainer()) //then must also rename from history ds
	{
		try {
			var hrn = histDS.getNode(s);
			hrn.addTargetOnce("http://home.netscape.com/NC-rdf#Name", newval);
		} catch (err) {}
	}
}

HypCommon.BKUpDown = function(s, k, bookDS, histDS)
{
	var movenode = bookDS.getNode(s);
	
	var parentnode = this.BKgetParent(movenode);
	
	var indx = parentnode.getChildIndex(movenode);
	if ((indx <= 1) && (k < 0)) return;
	
	var count = parentnode.getChildCount();
	if ((count == indx) && (k > 0)) return; //in case of move down (must not be last)
	parentnode.removeChildAt(indx);
	indx = indx + k;
	parentnode.addChildAt(movenode, indx);
	
	if (movenode.isContainer()) //move from history only if container
	{
	   try {
		var hmovenode = histDS.getNode(s);
		var hparentnode = this.BKgetParent(hmovenode);
		hparentnode.removeChild(hmovenode); //instead of using index use node
		hparentnode.addChildAt(hmovenode, indx);
	   } 
	   catch (err) 
	   { Hyper.dump.logStringMessage(err); }
	}
}

HypCommon.BKCheckPresent = function(bookmark, folder) //returns true if found
{
	var st = bookmark.getTarget("http://home.netscape.com/NC-rdf#Name");
	if (st != null) //has name thus must be already created
	{
	        var par = this.BKgetParent(bookmark);
	        if (par.getValue() == folder.getValue())
	        {	//maybe update....or no need?
	        	alert(HypCommon.getString("BK_ALREADY_EXISTS")); 
			return true;
	        }
	        else 
		{
			if (confirm(HypCommon.getString("BK_ALREADY_EXISTS_MV")))
			{
				par.removeChild(bookmark);
			}
			return true;
	        }
	}
	
	return false;
}

HypCommon.bkvcsortswap = function(a, b) //swap for bk rdf nodes sorting by visit count
{
	var an = a.getTarget("http://home.netscape.com/NC-rdf#VisitCount");
	var bn = b.getTarget("http://home.netscape.com/NC-rdf#VisitCount");
	var anv = parseInt(an.getValue());
	var bnv = parseInt(bn.getValue());
	
	return bnv - anv;
}

HypCommon.bksortswap = function(a, b)
{
	if ((a.isContainer()) && (b.isContainer()))
	{
		var an = a.getTarget("http://home.netscape.com/NC-rdf#Name");
		var bn = b.getTarget("http://home.netscape.com/NC-rdf#Name");
		if (an.getValue() > bn.getValue()) return 1; else return -1;
	}
	if (a.isContainer()) return -1;
	if (b.isContainer()) return 1;
	
	var an = a.getTarget("http://home.netscape.com/NC-rdf#Name");
	var bn = b.getTarget("http://home.netscape.com/NC-rdf#Name");
	if (an.getValue() > bn.getValue()) return 1; else return -1;
}

HypCommon.BKSort = function(bookDS)
{
	var bks = bookDS.getAllResources();
	while (bks.hasMoreElements())
	{
		var fol = bks.getNext();
		if (fol.isContainer())
		{
			var carr = new Array();
			var chil = fol.getChildren();
			while (chil.hasMoreElements()) carr[carr.length] = chil.getNext(); //convert to array
			
			for(var i=0; i<carr.length; i++) fol.removeChild(carr[i]);
			
			carr.sort(this.bksortswap);
			for(var i=0; i<carr.length; i++) fol.addChild(carr[i]);
		}
	}
}

HypCommon.BKSortFolder = function(bookDS, folder)
{
	var carr = new Array();
	var chil = folder.getChildren();
	while (chil.hasMoreElements()) carr[carr.length] = chil.getNext(); //convert to array
	
	for(var i=0; i<carr.length; i++) folder.removeChild(carr[i]);
				
	carr.sort(this.bksortswap);
	for(var i=0; i<carr.length; i++) folder.addChild(carr[i]);
}

//read exif

HypCommon.readExif = function(imgUrl)
{
	var istream;
	imgUrl = imgUrl.toLowerCase();
	if (imgUrl.indexOf("favicon") == -1) return null; //no favicon ...must be an image then return null
	try
	{
    		var cs = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
    		var httpCacheSession = cs.createSession("HTTP", 0, true);
    		var nsICache = Components.interfaces.nsICache;
    		// use false so we don't block!
    		var cdesc = httpCacheSession.openCacheEntry(imgUrl, nsICache.ACCESS_READ, false);
    		istream = cdesc.openInputStream(0);
  	
		    var bis = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
    		bis.setInputStream(istream);
    		var mBytes = new Array();
    		var mCountRead = 0;
    		
    		mCountRead = istream.available();
    		var chunk = bis.readByteArray(mCountRead);
    		mBytes = mBytes.concat(chunk);
    
    		return Base64.encode(mBytes);
    	}
    	catch(ex) { /*Hyper.dump.logStringMessage(ex);*/ return null; }
}


////
HypCommon.HYcheckStatus = function(doc) //workaround to get http status code
{
	if (doc.title == HypCommon.getString("PROBLEM_LOAD_PG")) return "offline";
	
	p = doc.title.toLowerCase();
	if ((p.indexOf("404") != -1) || (p.indexOf("found") != -1))
	{
		try
		{
			var url = doc.URL;
			var http_request = new XMLHttpRequest();
			http_request.open("HEAD", url, false); //synchronously
        		http_request.send(null);
        		if (http_request.status != 200) return "notfound";
        	}
        	catch (err) 
        	{ 
        		return "notfound";
        	}
	}
	
	return "";
}


////

HypCommon.limitHistory = function(hDS, prefs)
{
	var maxhist = prefs.getIntPref("extensions.hyper.maxhist");
	var ldate = new Date();
	ldate.setDate(ldate.getDate()-maxhist);
	var month = ldate.getMonth() + 1;
	ldate = ldate.getDate() + '|' + month + '|' + ldate.getFullYear();
	ldate = this.BKdateNormalize(ldate);
	
	var hnodes = hDS.getAllResources();
	while (hnodes.hasMoreElements())
	{
		var hn = hnodes.getNext();
		if (!hn.isContainer())
		{
			var hdt = hn.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
			if (hdt != null)
			{
				hdt = this.BKdateNormalize(hdt.getValue(), true);
				if (hdt < ldate)
				{
					hDS.deleteRecursive(hn);
				}
			}
			else
				hDS.deleteRecursive(hn); //no last visit date ...just delete
		}
	}
}

////
HypCommon.createDS = function(bookDS, fastDS, histDS) //create datasources and root nodes
{
	//Create Root Nodes for Bookmark File
	var broot = bookDS.getNode("NC:BookmarksRoot");
	if (!broot.isContainer())
	{
		var topr = bookDS.getNode("NC:BTopRoot");
		topr.makeSeq();
		topr.addTargetOnce("http://home.netscape.com/NC-rdf#Name", "BTopRoot");
		
		broot.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("BK_DS_NAME"));
		broot.makeSeq();
		
		topr.addChild(broot, false);
	}
	
	//Create Root Nodes for Fast Bookmarks
	if (fastDS != null)
	{
		var froot = fastDS.getNode("NC:FastBKRoot");
		if (!froot.isContainer())
		{
			froot.addTargetOnce("http://home.netscape.com/NC-rdf#Name", "FastBookmarksRoot");
			froot.makeSeq();
		}	
	}
	
	//Create Root Nodes for History
	var hroot = histDS.getNode("NC:BookmarksRoot");
	if (!hroot.isContainer())
	{
		var htopr = histDS.getNode("NC:BTopRoot");
		htopr.makeSeq();
		htopr.addTargetOnce("http://home.netscape.com/NC-rdf#Name", "HTopRoot");
			
		hroot.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("HS_DS_NAME"));
		hroot.makeSeq();
			
		htopr.addChild(hroot, false);
	}
}

HypCommon.repairDS = function(bookDS, fastDS, histDS)
{
	if (bookDS != null) //REPAIR BOOKMARKS
	{
		var broot = bookDS.getNode("NC:BookmarksRoot");
		var topr = bookDS.getNode("NC:BTopRoot");
		topr.makeSeq();
		topr.addTargetOnce("http://home.netscape.com/NC-rdf#Name", "BTopRoot");
				
		broot.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("BK_DS_NAME"));
		broot.makeSeq();
				
		topr.addChild(broot, false);
	}
	
	if (fastDS != null) //REPAIR FASTBOOKMARKS
	{
		var froot = fastDS.getNode("NC:FastBKRoot");
		froot.addTargetOnce("http://home.netscape.com/NC-rdf#Name", "FastBookmarksRoot");
		froot.makeSeq();	
	}
	
	if (histDS != null) //REPAIR HISTORY
	{
		var hroot = histDS.getNode("NC:BookmarksRoot");
		
		var htopr = histDS.getNode("NC:BTopRoot");
		htopr.makeSeq();
		htopr.addTargetOnce("http://home.netscape.com/NC-rdf#Name", "HTopRoot");
				
		hroot.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("HS_DS_NAME"));
		hroot.makeSeq();
				
		htopr.addChild(hroot, false);
	}
}
/////
HypCommon.getSE = function(preferences) ///returns array of search engines [0] - url, [1] query variable
{
	var se = preferences.getCharPref("extensions.hyper.seurl");
	var se = se.split(';');
	for(var i=0; i<se.length; i++)
	{
		se[i] = se[i].split(',');
	}
	return se;
}

HypCommon.seURL = function(se, reff) //checks if reff is a url to a search engine search
{
	for(var i=0; i<se.length; i++)
	{
		if (reff.indexOf(se[i][0]) > 0) return i; //found at location i
	}
	return -1; //returns -1 if not found
}
////////

HypCommon.URLMatch = function(furl, alink) //params: bookmark url, page anchor tag
{
	var purl = alink.href;
	if (furl == purl) return 1;
	
	var ret = 0;
	
	if (alink.protocol.indexOf("http") < 0) return 0; //not http or https
	
	var path = alink.pathname+alink.search;
	purl = alink.hostname;
	
	if (furl.indexOf(purl) != -1) //found
	{
		ret++; //1
		if ((path == "") || (path == "/")) 
		{ /*do nothing*/ } 
		else ret++; //2
	}
	
	return ret;
}
////

HypCommon.addFoldersCBox = function(fol, cbox) //adds folder names to dropdown list *recursive*
{
	var chil = fol.getChildren();
	while (chil.hasMoreElements())
	{
		var c = chil.getNext();
		if (c.isContainer())
		{
			try {
				var st = c.getTarget("http://home.netscape.com/NC-rdf#Name");
				cbox.appendItem(st.getValue(), c.getValue());
			} catch(err) { }
			this.addFoldersCBox(c, cbox);
		}
	}
}

HypCommon.clipBoard = function(copytext)
{
	var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard);
   	if (!clip) return;
   
   	var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
   	if (!trans) return;
   
   	trans.addDataFlavor('text/unicode');
   
   	var str = new Object();
   	var len = new Object();
   
   	var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
      
   	str.data=copytext;
   
   	trans.setTransferData("text/unicode",str,copytext.length*2);
   
   	var clipid=Components.interfaces.nsIClipboard;
   
   	clip.setData(trans,null,clipid.kGlobalClipboard);
}

HypCommon.gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
HypCommon.lStrings = HypCommon.gBundle.createBundle("chrome://hyper/locale/hyper.properties");
HypCommon.getString = function(localString)
{
	try {
		return this.lStrings.GetStringFromName(localString);
	}
	catch (err)
	{	
		return localString;
	}
}

function HYTrim(s)
{
	return s.replace(/^\s+|\s+$/, "");
}