var Hyper = null;
var histDS = null;
var tempDS = null;
var Amain = false;
var histtree;
var lbfilter;
var cbox;
var clist;
var HY_OpenTab;
var prefs;

function Startup()
{	
	Hyper = window.arguments[0];
	HY_OpenTab = window.arguments[1];
	
	histDS = Hyper.histDS;
	
	lbfilter = document.getElementById("filtername");
	lbfilter.value = HypCommon.getString("HF_NO");
	
	cbox = document.getElementById("clist");
	cbox.addEventListener("keypress", tbkeypress, false);
	
	histtree = document.getElementById("histtree");
	histtree.database.AddDataSource(Hyper.histDS.getRawDataSource());
	histtree.builder.rebuild();
	histtree.addEventListener("dblclick", openHLink, false);
	Amain = true;
	
	prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
}

function tbkeypress(e)
{
	if (e.keyCode == 13) View();
}

function View()
{
	if (Amain) histtree.database.RemoveDataSource(Hyper.histDS.getRawDataSource());
	else histtree.database.RemoveDataSource(tempDS.getRawDataSource());
	
	switch (lbfilter.value)
	{
		case HypCommon.getString("HF_NO") : { //NO FILTER
				histtree.database.AddDataSource(Hyper.histDS.getRawDataSource());
				Amain = true;
				break;
		}
		case HypCommon.getString("HF_DT") : { //Date
				filterByDate(cbox.value);
				
				histtree.database.AddDataSource(tempDS.getRawDataSource());
				Amain = false;
				break;
		}
		case HypCommon.getString("HF_SC") : { //Section	
				filterBySection(cbox.selectedItem.value);
					
				histtree.database.AddDataSource(tempDS.getRawDataSource());
				Amain = false;
				break;
		}
		case HypCommon.getString("HF_VC") : {  //Visit Count
				filterByVC(cbox.value); //selectedItem.label);
				
				histtree.database.AddDataSource(tempDS.getRawDataSource());
				Amain = false;
				break;
		}
		case HypCommon.getString("HF_KW") : {  //Keyword
				filterByKW(cbox.value);
				
				histtree.database.AddDataSource(tempDS.getRawDataSource());
				Amain = false;
				break;
		}
		case HypCommon.getString("HF_PR") : { //Period
				try {
					vsamp2();
				}
				catch (err) { }
				histtree.database.AddDataSource(tempDS.getRawDataSource());
				Amain = false;
				break;
		}
		default : { }
	}
	window.document.title = HypCommon.getString("HV_TIT")+" ("+ lbfilter.value +")";	
	histtree.builder.rebuild();
}

function tbbNone()
{
	lbfilter.value = HypCommon.getString("HF_NO");
	//clear datelistpop
	cbox.removeAllItems();
	cbox.value = "";
	cbox.setAttribute("editable", "false");
}

function tbbDate()
{
	var maxhist = prefs.getIntPref("extensions.hyper.maxhist");
	maxhist = maxhist + 1;
	
	lbfilter.value = HypCommon.getString("HF_DT");
	// appendItem ( label , value , description )
	cbox.removeAllItems();
	cbox.setAttribute("editable", "true");
	var s = "";
	var ddate = new Date();
	ddate.setDate(ddate.getDate()-maxhist);
	for (var i=0; i<maxhist; i++)
	{
		ddate.setDate(ddate.getDate()+1);
		var month = ddate.getMonth() + 1;
		s = ddate.getDate() + '|' + month + '|' + ddate.getFullYear();
		cbox.appendItem(s, s, "");
	}
}



function tbbSec()
{
	lbfilter.value = HypCommon.getString("HF_SC");
	cbox.removeAllItems();
	cbox.setAttribute("editable", "false");
	HypCommon.addFoldersCBox(histDS.getNode("NC:BTopRoot"), cbox);
}

function tbbVCount()
{
	lbfilter.value = HypCommon.getString("HF_VC");
	cbox.removeAllItems();
	cbox.setAttribute("editable", "true");
	for(var i=0; i<55; i=i+5)
	{
		cbox.appendItem(i+"", i, "");
	}
}

function tbbkeysearch()
{
	lbfilter.value = HypCommon.getString("HF_KW");
	cbox.removeAllItems();
	cbox.setAttribute("editable", "true");
}

//////

function filterByDate(date)
{
	date = HypCommon.BKdateNormalize(date);
	tempDS = new RDFDataSource();
	Hyper.histDS.copyAllToDataSource(tempDS);
	
	var nodes = tempDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var n = nodes.getNext();
		if (!n.isContainer())
		{
			var dt = n.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
			var dn = HypCommon.BKdateNormalize(dt.getValue(), true);
			if (dn != date)
			{
				tempDS.deleteRecursive(n);
			}
		}
	}
}

function filterByVC(vcmax)
{
	tempDS = new RDFDataSource();
	Hyper.histDS.copyAllToDataSource(tempDS);
	
	var nodes = tempDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var n = nodes.getNext();
		if (!n.isContainer())
		{
			var vct = n.getTarget("http://home.netscape.com/NC-rdf#VisitCount");
			if (vct != null) vct = parseInt(vct.getValue());
			if (vct < vcmax)
			{
				tempDS.deleteRecursive(n);
			}
			
		}
	}
}


function delNSec(fol, sec)
{
	if (!fol.isContainer()) tempDS.deleteRecursive(fol);
	
	var chil = fol.getChildren();
	while (chil.hasMoreElements())
	{
		var ch = chil.getNext();
		
		if (ch.getValue() == sec) { /* do nothing */ }
		else if (ch.isContainer()) 
		{
			delNSec(ch, sec);
			tempDS.deleteRecursive(ch);
		}
		else tempDS.deleteRecursive(ch);
	}
}

function filterBySection(section)
{
	tempDS = new RDFDataSource();
	Hyper.histDS.copyAllToDataSource(tempDS);
	
	var rt = tempDS.getNode("NC:BookmarksRoot");
	delNSec(rt, section);
}

function filterByKW(word)
{
	word = word.toLowerCase();
	tempDS = new RDFDataSource();
	Hyper.histDS.copyAllToDataSource(tempDS);
	
	var bks = tempDS.getAllResources();
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (!bk.isContainer())
		{
		   try {
			var name = bk.getTarget("http://home.netscape.com/NC-rdf#Name");
			var url = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
			var keywords = bk.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
			var s = name.getValue() + " " + url.getValue() + " " + keywords.getValue();
			s = s.toLowerCase();
			if (HypCommon.searchMatch(word, s) < 0)
				tempDS.deleteRecursive(bk);
		   } catch (err) {}
		}
	}
}

function filterByPeriod(sper, eper)
{
	tempDS = new RDFDataSource();
	Hyper.histDS.copyAllToDataSource(tempDS);
		
	var bks = tempDS.getAllResources();
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (!bk.isContainer())
		{
			var lvd = bk.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
			lvd = HypCommon.BKdateNormalize(lvd.getValue());
			if (!((lvd > sper) && (lvd < eper)))
			{
				tempDS.deleteRecursive(bk);
			}
		}
	}
}
/////

function nukeAllHistory()
{
	if (!confirm(HypCommon.getString("SURE_DEL_ALLH"))) return;
	
	var nodes = histDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var n = nodes.getNext();
		if (!n.isContainer()) histDS.deleteRecursive(n);
	}
}

function nukeViewHistory()
{
	if (tempDS == null)
	{
		alert(HypCommon.getString("SEL_VIEW_FIRST"));
		return;
	}
	if (!confirm(HypCommon.getString("SURE_DEL_THIST"))) return;
	
	var nodes = tempDS.getAllResources();
	while (nodes.hasMoreElements())
	{
		var n = nodes.getNext();
		if (!n.isContainer())
		{
			var dn = histDS.getNode(n.getValue());
			histDS.deleteRecursive(dn);
			tempDS.deleteRecursive(n); //?
		}
	}
	
}

/////


function openHLink(e)
{
	var i = -1;
	if (histtree.view != null) //in case of newly created bookmark file
		i = histtree.view.selection.currentIndex;
	if (i == -1) return
	
	//var nname = histtree.view.getItemAtIndex(i).id;
	var nname = histtree.view.getResourceAtIndex(i).Value;
	var nd = histDS.getNode(nname);
	if (nd.isContainer()) return;
	var hurl = nd.getTarget("http://home.netscape.com/NC-rdf#URL");
	HY_OpenTab(hurl.getValue());
}


function highlightRef()
{
	var i = -1;
	if (histtree.view != null) //in case of newly created bookmark file
		i = histtree.view.selection.currentIndex;
	if (i == -1) return
		
	var nname = histtree.view.getResourceAtIndex(i).Value;
	var nd = histDS.getNode(nname);
	if (nd.isContainer()) return;
	var refurl = nd.getTarget("http://home.netscape.com/NC-rdf#Referrer");
	if (refurl == null)
	{
		alert(HypCommon.getString("NO_REF_E"));
		return;
	}
	refurl = refurl.getValue();
	
	treeexp(true);
	var flg = true;
	for(var j=0; j<histtree.view.rowCount; j++)
	{
		if (refurl == histtree.view.getItemAtIndex(j).id)
		{
			histtree.view.selection.select(j);
			histtree.treeBoxObject.ensureRowIsVisible(j);
			flg = false;
			break;
		}
	}
	
	if (flg) alert(HypCommon.getString("NO_REF_F"));
}

////
function vsamp2()
{
	var i = -1;
	if (histtree.view != null) //in case of newly created bookmark file
		i = histtree.view.selection.currentIndex;
	if (i == -1) return
		
	var nname = histtree.view.getResourceAtIndex(i).Value;
	var nd = histDS.getNode(nname);
	if (nd.isContainer()) return;
	var hlvd = nd.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
	var date = HypCommon.sDateConv(hlvd.getValue());
		
	var ph = prefs.getIntPref("extensions.hyper.periodhours");
	if (ph == 0) ph = 2;
	var phours = ph * 1000;
	
	var futdate = new Date(date);
	var expdate = futdate.getTime();
	expdate += 3600*phours; //expires x milliseconds (hours)
	futdate.setTime(expdate);

	var pasdate = new Date(date);
	expdate = pasdate.getTime();
	expdate -= 3600*phours; //expires x milliseconds (hours)
	pasdate.setTime(expdate);
	
	futdate = HypCommon.BKdateNormalize(HypCommon.dateToStr(futdate, true));
	pasdate = HypCommon.BKdateNormalize(HypCommon.dateToStr(pasdate, true));
	
	filterByPeriod(pasdate, futdate);
}

function vsamp()
{
	lbfilter.value = HypCommon.getString("HF_PR");
	cbox.removeAllItems();
	
	View(); //apply filter
}


///
function treeexp(ec) //expand or collapse tree
{
	for(var i=histtree.view.rowCount-1; i>=0; i--)
	{
		if (histtree.view.isContainer(i))
		if (histtree.view.isContainerOpen(i) == !ec) histtree.view.toggleOpenState(i);
	}
}