var Hyper = null;

function Startup()
{
	Hyper = window.arguments[0];
	
	var f = openBKFile(); //wait for doc to load....
	if (f == false)
	{
		window.close();
		return;
	}
	var extpos = f.lastIndexOf('.');
	var ext = f.substr(extpos+1, f.length-(extpos+1));
	ext = ext.toLowerCase();
	
	if (ext == "rdf")
	{
		var bookDStoimp = new RDFDataSource(f);
		bookDStoimp.copyAllToDataSource(Hyper.bookDS);
		Hyper.RepairDS(false);
		Hyper.bookDS.save();
		alert(HypCommon.getString("BK_IMPORTED"));
		Hyper.LoadURLs();
		window.close();
	}
	else
	{
		var hiframe = window.document.getElementById("hiframe");
		hiframe.setAttribute("src", f);
		//hiframe.addEventListener("DOMContentLoaded", ImportBK, true);
		hiframe.addEventListener("load", ImportBK, true);
	}
}

function ImportBK()
{
	if (!confirm(HypCommon.getString("SURE_IMPORT"))) return;
	var htmldoc = hiframe.document;
	ImportBKS(htmldoc, Hyper.bookDS, Hyper.histDS);
	Hyper.LoadURLs();
	window.close();
}

////////////////////

function travFolder(cnodes, prdffolder, bkdesc)
{
	if (prdffolder == null) return;
	var rdffolder = null;
	
	for(var i=0; i<cnodes.length; i++)
	{
		var cnode = cnodes[i];
		try {
		   switch (cnode.nodeName)
		   {
			case "H3" : {
					var rnum = "";
					var fn = cnode.firstChild.nodeValue; 
					var furi = fn.replace(/\s/g, "_");
					rdffolder = bDS.getNode("NC:"+furi);
					while (rdffolder.isContainer()) //duplicate when importing
					{
						rnum = Math.floor(Math.random() * 9)+1;
						rnum = (rnum == 0) ? "" : "_"+rnum.toString();
						rdffolder = bDS.getNode("NC:"+furi+rnum);
					}
					rdffolder.addTargetOnce("http://home.netscape.com/NC-rdf#Name", fn+rnum);
					
					try {
						var adate = cnode.getAttribute("ADD_DATE");
						if ((adate != null) && (adate != ""))
						{
							var dates = new Date(parseInt(adate) * 1000);
							dates = HypCommon.dateToStr(dates, false); //no time
							rdffolder.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", dates); //fixed ... new
						}
					} catch (err) { }
					
					rdffolder.makeSeq();
					prdffolder.addChild(rdffolder, false);
					break;
			}
			case "DL" : {
					if (rdffolder != null) travFolder(cnode.childNodes, rdffolder); 
					else travFolder(cnode.childNodes, prdffolder);
					rdffolder = null;
					break;
			}
			case "DT" : { //contains an A tag
					var dddesc = null;
					try //for Description
					{
					     if (i+1 < cnodes.length)
					     {
						var cn = cnodes[i+1];
						if (cn.nodeName == "DD")  //get first child
							if (cn.childNodes[0].nodeName == "#text")
								dddesc = cn.childNodes[0].nodeValue;
					     }
					}
					catch (err) {}
					
					if (rdffolder != null) travFolder(cnode.childNodes, rdffolder, dddesc); 
					else travFolder(cnode.childNodes, prdffolder, dddesc);
					break;
			}
			case "DD" : { //contains DL
					if (rdffolder != null) travFolder(cnode.childNodes, rdffolder); 
					else travFolder(cnode.childNodes, prdffolder);
					rdffolder = null;
					break;
			}
			case "A" : { 
				var href = cnode.getAttribute("href");
				var icon = cnode.getAttribute("icon");
				var name = cnode.firstChild.nodeValue; 
				
				var bkn = bDS.getNode("NC:"+href);
				var temp = bkn.getTarget("http://home.netscape.com/NC-rdf#Name");
				if (temp == null) //do not add dublicates
				{
					bkn.addTargetOnce("http://home.netscape.com/NC-rdf#Name", name);
					bkn.addTargetOnce("http://home.netscape.com/NC-rdf#URL", href);
					bkn.addTargetOnce("http://home.netscape.com/NC-rdf#Page", name);
					bkn.addTargetOnce("http://home.netscape.com/NC-rdf#VisitCount", "1");
					
					try 
					{
						var adate = cnode.getAttribute("ADD_DATE");
						if ((adate != null) && (adate != ""))
						{
							var dates = new Date(parseInt(adate) * 1000);
							dates = HypCommon.dateToStr(dates, false); //no time
							bkn.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", dates); //fixed ... new
						}
						else
						{
							bkn.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", "");
						}
					} 
					catch (err) 
					{ 
						bkn.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", "");
					}
					
					bkn.addTargetOnce("http://home.netscape.com/WEB-rdf#LastVisitDate", "");
					bkn.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", "");
					bkn.addTargetOnce("http://home.netscape.com/NC-rdf#OrigKeywords", "");
					if ((icon != null) && (icon != ""))
					   bkn.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", icon);
					else
					   bkn.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", "chrome://hyper/content/images/file.png");
					if (bkdesc != null)
					{
						bkn.addTargetOnce("http://home.netscape.com/NC-rdf#Description", bkdesc);
					}
					prdffolder.addChild(bkn, false);
				}
				break;
			}
			default : {}
		   }
		} catch (err) { alert(err.message); }
		
	}
}

var bDS = null;

function ImportBKS(htmldoc, DS, histDS)
{
	try
	{
		if (htmldoc.defaultView.document.doctype.nodeName.toLowerCase() != "netscape-bookmark-file-1")
		{
			alert(HypCommon.getString("INVALID_BK_FILE"));
			return;
		}
		bDS = DS;
		HypCommon.createDS(Hyper.bookDS, null, Hyper.histDS);
		
		var root = bDS.getNode("NC:BookmarksRoot");
		travFolder(htmldoc.body.childNodes, root);
		createEquivHistory(histDS); //create history (categories)
		alert(HypCommon.getString("BK_IMPORTED"));
		
		//save to disk
		bDS.save();
		histDS.save();
	}
	catch (err)
	{
		alert(HypCommon.getString("ERR_BK_IMP")+"\r\n" + err.message);
	}
}


function crHist(bfol, hfol, hDS)
{
	var nodes = bfol.getChildren();
	while (nodes.hasMoreElements())
	{
		var ch = nodes.getNext();
		if (ch.isContainer())
		{
			var fn = ch.getTarget("http://home.netscape.com/NC-rdf#Name");
			var hn = hDS.getNode(ch.getValue());
			hn.addTargetOnce("http://home.netscape.com/NC-rdf#Name", fn.getValue());
			hn.makeBag();
			hfol.addChild(hn, false);
			
			crHist(ch, hn, hDS);
		}
	}
}

function createEquivHistory(histDS)
{
	var broot = bDS.getNode("NC:BookmarksRoot");
	var hroot = histDS.getNode("NC:BookmarksRoot");
	if (!hroot.isContainer()) hroot.makeBag();
	crHist(broot, hroot,  histDS);
}


function openBKFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	
	fp.init(window, HypCommon.getString("SELECT_FILE"), nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterHTML);
	fp.appendFilter("RDF File","*.rdf");
	var fpres = fp.show();
	if (fpres == nsIFilePicker.returnCancel) return false;
	
	var path = fp.file.path;
	path = "file://" + path.replace(/\s/g, "%20");
	
	return path;
}