////////////////////////////////////////////////////
///HyperBK Overlay for Mozilla Firefox 1.5
///=======================================
///Ian Bugeja 2006
///B.Sc. I.T. (Hons.)
///Year 4
///University of Malta - Department of Computer Science and Artificial Intelligence
///
///Managing WWW Browsers Bookmarks and History
///
////////////////////////////////////////////////////

var Hyper = new Object();

Hyper.bookDS = null; //bookmark datasource
Hyper.fastbkDS = null; //fast bookmark datasource
Hyper.histDS = null; //history datasource
Hyper.pathDS = null;
Hyper.pathFDS = null;
Hyper.pathHDS = null;
Hyper.dump = null;
Hyper.Tour = null;
Hyper.TourCount = -1;
Hyper.keywordsBF = null;
Hyper.urlsBK = null;
Hyper.fullTour = null;
Hyper.topBKDS = null;


Hyper.OnLoad = function(pathB, pathF, pathH)
{
	this.bookDS = new RDFDataSource(pathB);
	this.pathDS = pathB;
	this.fastbkDS = new RDFDataSource(pathF);
	this.pathFDS = pathF
	this.histDS = new RDFDataSource(pathH);
	this.pathHDS = pathH;
	
	HypCommon.createDS(this.bookDS, this.fastbkDS, this.histDS); //create if new
	
	this.keywordsBF = new Array();
	this.urlsBK = new Array();
	this.dump = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
}

Hyper.Log = function(s)
{
	this.dump.logStringMessage(s);
}

Hyper.Message = function()
{
	var brow = HY_MostRecentWindow().getBrowser().selectedBrowser;
	var s = "";
	if (!brow.contentDocument.hyperTF) return;
	
	var rtf = brow.contentDocument.hyperTF;
	for(var i=0; i<rtf.length; i++)
	{
		s = s+"|" + rtf[i][0] + "| = " + rtf[i][1]+", "+rtf[i][2]+"\r\n";
	}
	
	var sp = "\r\n\r\nBookmark Scores\r\n";
	var bkmatches = brow.contentDocument.hyperMatches;
	if (bkmatches)
	{
		for(var i=0; i<bkmatches.length; i++)
		{
			var sn = bkmatches[i][0].getTarget("http://home.netscape.com/NC-rdf#Name");
			sp = sp + sn.getValue() + " " + bkmatches[i][1] + "\r\n";
		}
	}
	
	alert("Page Keywords\r\n" + s + sp);
}

Hyper.SEMessage = function()
{
	var refurl = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument.referrer;
	var seref = this.GetSearchReferrer(refurl);
	if (seref == null) alert(HypCommon.getString("NO_SE_REF"));
	else alert(HypCommon.getString("SE_REF") + ": "+seref);
}

Hyper.BKInfo = function()
{
	var cont = 0;
	var bks = 0;
	var allbk = this.bookDS.getAllResources();
	while  (allbk.hasMoreElements())
	{
		var bk = allbk.getNext();
		if (bk.isContainer()) cont++; else bks++;
	}
	cont = cont - 2; //remove BookmarksRoot and BTopRoot
	var rcont = 0;
	var rbks = 0;
	var root = this.bookDS.getNode("NC:BookmarksRoot");
	var chil = root.getChildren();
	while (chil.hasMoreElements())
	{
		var bk = chil.getNext();
		if (bk.isContainer()) rcont++; else rbks++;
	}
	alert("Categories: "+cont+"\r\nBookmarks: "+bks+"\r\n\r\nRoot Categories: "+rcont+"\r\nRoot Bookmarks: "+rbks);
}

/*Hyper.SelText = function() //not used
{
	var doc = window.getBrowser().selectedBrowser.contentWindow;
	var sel = doc.getSelection();
	alert(sel.focusNode.nodeValue);
}*/

Hyper.ImportBK = function()
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperImportBK.xul", "" , "centerscreen,chrome,dialog=yes,modal=yes,resizable=yes,height=300,width=800", this);
}

Hyper.ExportBK = function()
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperBKExport.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,height=500,width=600", this.bookDS);
}

Hyper.RepairDS = function(showalert)
{
	HypCommon.repairDS(this.bookDS, this.fastbkDS, this.histDS);
	
	var root = this.bookDS.getNode("NC:BookmarksRoot");
	
	var allbk = this.bookDS.getAllResources();
	while  (allbk.hasMoreElements())
	{
		var bk = allbk.getNext();
		var bkparent = HypCommon.BKgetParent(bk);
		if (bkparent == null)
		{
			if (bk.getValue() != "NC:BTopRoot") //toppest root has no parent
			{
				root.addChild(bk, false);
				bkparent = root;
				this.Log("Found Lost Bookmark");
			}
		}
		else if ((bkparent.getValue() != "NC:BTopRoot") && (bkparent.getValue() != "NC:BookmarksRoot"))
		{
			if (bk.isContainer())
			{
				try { //trying to see if a loop exists
					var Lcnt = 0;
					var upperroot = bkparent;
					do
					{
						upperroot = HypCommon.BKgetParent(upperroot);
						Lcnt++;
						if (Lcnt > 20) break;
					}
					while (upperroot.getValue() != "NC:BookmarksRoot");

					if (upperroot.getValue() != "NC:BookmarksRoot")
					{
						this.Log("Loop Detected " + bk.getValue());
						bkparent.removeChild(bk);
						root.addChild(bk, false);
					}
				} catch (err) { this.Log("Loop Detect Failed " + err); }
			}
		}
		
		if (bk.isContainer())
		{
			var bkfname = bk.getValue();
			var hfol = this.histDS.getNode(bkfname); //get and create
			hfol.addTargetOnce("http://home.netscape.com/NC-rdf#Name", bk.getTarget("http://home.netscape.com/NC-rdf#Name"));
			hfol.makeBag(); //make sure it is bag
			
			if (bkparent != null) //create history parent node
			{
				var hfolparent = this.histDS.getNode(bkparent.getValue());
				hfolparent.makeBag();
				hfolparent.addChild(hfol, false);
			}
		}
	}
	
	var hrootfol = this.histDS.getNode("NC:BookmarksRoot");
	hrootfol.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("HS_DS_NAME"));	
	
	if (showalert == null) alert(HypCommon.getString("BKFILE_REPAIRED"));
}

Hyper.regenBF = function() //load bookmark folder [0] and keywords[1] in array for fast access, also save to keywords in bookmark file
{
	this.keywordsBF = new Array(); //reinitialise
	var allbk = this.bookDS.getAllResources();
	while  (allbk.hasMoreElements())
	{
		var bk = allbk.getNext();
		if ((bk.isContainer()) && (bk.getValue() != "NC:BookmarksRoot")) //never suggest in root
		{
			var bkchildren = bk.getChildren();
			var s = "";
			while (bkchildren.hasMoreElements())
			{
				var bki = bkchildren.getNext();
				if (!bki.isContainer())
				{
					var st = bki.getTarget("http://home.netscape.com/NC-rdf#Keywords");
					if (st != null) s = s + st.getValue();
				}
			}
			//check for duplicates
			var sas = s.split(";");
			for(var i=0; i<sas.length; i++) sas[i] = new Array(sas[i], 1);
			
			for(var i=0; i<sas.length; i++)
			{
				if (sas[i][0] != "")
				for(var j=0; j<sas.length; j++)
				{
					if ((i != j) && (sas[i][0] == sas[j][0]))
					{
						sas[j][0] = "";
						sas[i][1] = sas[i][1] + 1; //term frequency
					}
				}
			}
			var gone = 0; //greater than one
			for(var i=0; i<sas.length; i++) { if (sas[i][1] > 1) gone++; } //count how many > 1
			
			s = "";
			for(var i=0; i<sas.length; i++)
			{
				if (sas[i][0] != "") 
				if (gone > 9)
				{
				     if (sas[i][1] > 1) s = s + sas[i][0] + ";"; //only add if occurance more than 1
				}
				else s = s + sas[i][0] + ";";
			}
			
			this.keywordsBF[this.keywordsBF.length] = new Array(bk, s);
			bk.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", s);
		}
	}
	
	this.bookDS.save();
}

Hyper.FastRegenBF = function() //like above but do not compute (just load)
{
	this.keywordsBF = new Array(); //reinitialise
	var allbk = this.bookDS.getAllResources();
	while  (allbk.hasMoreElements())
	{
		var bk = allbk.getNext();
		if ((bk.isContainer()) && (bk.getValue() != "NC:BookmarksRoot"))
		{
			var s = bk.getTarget("http://home.netscape.com/NC-rdf#Keywords");
			if (s != null) s = s.getValue(); else s = "";
			
			this.keywordsBF[this.keywordsBF.length] = new Array(bk, s);
		}
	}
}


Hyper.LoadURLs = function() //load bookmark urls to array for fast access
{
	this.urlsBK = new Array();
	var allbk = this.bookDS.getAllResources();
	var surl = null;
	while  (allbk.hasMoreElements())
	{
		var bk = allbk.getNext();
		if (!bk.isContainer())
		{
			surl = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
			if (surl != null)
			{
				var sl = surl.getValue(); sl = sl.replace(/\/$/ , "");
				this.urlsBK[this.urlsBK.length] = sl;
			}
		}
	}
	
	this.urlsBK.sort();
}

Hyper.ForcastBKParent = function(url, matchesF, ptitle, hypTF) //params: url, array with mathces with each category, page title, page keyword & tf
{
	if (url.indexOf("http://") == 0) url = url.substring(7, url.length-1); //remove http:// or https://
	else if (url.indexOf("https://") == 0) url = url.substring(8, url.length-1);
	
	if (url.indexOf("www.") == 0) url = url.substr(4, url.length-4); //remove www
	else
	{ //if does not start with www but has more than 3 . like:home.um.edu.mt remove first one thus um.edu.mt
		var c = 0;
		for(var x=0; x<url.length; x++) 
		{	
			if (url[x] == ".") c++;
			if (url[x] == "/") break;
		}
		if (c >= 3) url = url.substring(url.indexOf(".")+1, url.length);
	}
	
	if (url.indexOf("/") != -1) url = url.substring(0, url.indexOf("/")); //remove trailing path keeping domain
	
	var count = 0;
	var allbk = this.bookDS.getAllResources();
	var bkres = new Array();
	while (allbk.hasMoreElements()) //get urls and check for url matches
	{
		var f = allbk.getNext();
		if (f.isContainer())
		{
			var bks = f.getChildren();
			count = 0;
			while (bks.hasMoreElements())
			{
				var bk = bks.getNext();
				var st = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
				if (st != null) //in case of folder
				{
					var s = st.getValue();
					if (s.indexOf(url) != -1) count = count +1;
				}
			}
			if (count > 0)
			{
				bkres[bkres.length] = new Array(f.getValue(), count); //[0] = uri, [1] = match count
			}
		}
	}
	if (bkres.length > 1) bkres.sort(HYsortwords);
	
	if ((matchesF == null) && (bkres.length == 0)) return null; //nothing pointed out
	
	if (matchesF != null)
	if (matchesF[0] != null)
	{
		if ((matchesF[0][1] == 0) && (bkres.length == 0)) return null; //nothing pointed out
		if ((matchesF[0][1] == 0) && (bkres.length > 0))
		{
			//bkres.sort(HYsortwords);
			return bkres[0][0]; //return one with highest hit
		}
		
		for(var i=0; i<matchesF.length; i++)
		{
			if (matchesF[i][1] > 0) //at least keyword match
			{
				var suri = matchesF[i][0].getValue();
				for(var j=0; j<bkres.length; j++)
				{
					if ((bkres[j][0] == suri) && (suri != "NC:BookmarksRoot")) //got a match
						return suri; //both algos pointed to same parent folder
				}
			}
		}
		if (matchesF[0][1] > 1) return matchesF[0][0].getValue(); //keyword hit more than 1
		if ((matchesF[0][1] > 0) && (matchesF[1][1] > 0)) //multiple sections with keyword hit of 1
		{
			for(var i=0; i<hypTF.length; i++) //compare keyword with category to get the top one
			{
				if (hypTF[i][1] > 3) //term freq must be greater than 3
				for(var j=0; j<matchesF.length; j++)
				{
					if (matchesF[j][1] > 0) //matched category
					{
						var bkk = matchesF[j][0].getTarget("http://home.netscape.com/NC-rdf#Keywords");
						bkk = bkk.getValue();
						bkk = bkk.split(";");
						for(var k=0; k<bkk.length; k++)
						{
							if (hypTF[i][0] == bkk[k]) return matchesF[j][0].getValue();
						}
					}
				}
			}
			
			ptitle = ptitle.toLowerCase();
			ptitle = ptitle.replace(/[^A-Z|a-z]+/g , " "); //remove all chars except letters
			ptitle = ptitle.split(" ");
			for(var i=0; i<matchesF.length; i++)
			{
				if (matchesF[i][1] > 0) //try to match with title
				{
					var bkk = matchesF[i][0].getTarget("http://home.netscape.com/NC-rdf#Keywords");
					bkk = bkk.getValue();
					bkk = bkk.split(";");
					for(var j=0; j<bkk.length; j++)
					for(var k=0; k<ptitle.length; k++)
						if (bkk[j] == ptitle[k]) return matchesF[i][0].getValue();
				}
			}
		}
		if (matchesF[0][1] > 0) return matchesF[0][0].getValue(); //keyword hit = 1 in 1 section only 
	} 
	else if(bkres.length > 0)
	{
		//bkres.sort(HYsortwords);
		return bkres[0][0]; //return one with highest hit
	}
	
	return null; //?
}

Hyper.Thumbnail = function()
{
	var cwin = HY_MostRecentWindow().getBrowser().selectedBrowser.contentWindow;
	//window.openDialog("chrome://hyper/content/hyperThumbnail.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=180,width=150", cwin, null);
	//var canvas = window.getBrowser().selectedBrowser.contentWindow.hyperCanvas;
	var htmldoc = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument;
	var canvas = htmldoc.getElementById("hyperthumb");
	var saveloc = HypCommon.randomString();
	HypCommon.saveThumbFile(saveloc, canvas);
}

Hyper.Bookmark = function()
{
  var htmldoc = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument;
  var hypTF = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument.hyperTF;
  var matchesF = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument.hyperMatches;
  var bwin = HY_MostRecentWindow().getBrowser().selectedBrowser.contentWindow;

	//check that bookmark not already present
	if (prefs.getBoolPref("extensions.hyper.allowrebook") == false)
	{
		var chil = this.bookDS.getAllResources();
		while (chil.hasMoreElements())
		{
			var bk = chil.getNext();
			if (!bk.isContainer())
			{
				try {
				var st = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
				if (st.getValue() == htmldoc.URL)
				{
					alert(HypCommon.getString("ALREADY_PRESENT_BK"));
					return;
				}
				} catch (err) {}
			}
		}
	}

	//Determine the most likely bookmark parent folder
	var sLoc = null;
	var forcast = this.ForcastBKParent(htmldoc.URL, matchesF, htmldoc.title, hypTF);
	if (forcast != null)
	{
		sLoc = this.bookDS.getNode(forcast);
	}
	else if (HY_MostRecentWindow().hyperLastBKF) //get last place where user bookmarked
	{
		sLoc = this.bookDS.getNode(HY_MostRecentWindow().hyperLastBKF);
	}
	else //all failed then Bookmark parent = ROOT
	{
		sLoc = this.bookDS.getNode("NC:BookmarksRoot");
	}
	
	var sicon = null;
	try {
		var icon = null;
		var rooturl = "";
		try{
			rooturl = htmldoc.URL;
			var endslash = rooturl.indexOf('/', 9)
			if (endslash > 0) rooturl = rooturl.substring(0, endslash);
			if (rooturl.charAt(rooturl.length-1) == '/')
				icon = rooturl + "favicon.ico";
			else
				icon = rooturl + "/favicon.ico";
		} 
		catch (err) 
		{ 
			this.dump.logStringMessage("favicon " +err.message);
			rooturl = ""; 
		}
		
		if (rooturl == "")
		{
			icon = HY_MostRecentWindow().getBrowser().selectedBrowser.mIconURL;
		}
		
		if (icon != "") 
		{
			sicon = HypCommon.readExif(icon); //read exif data
			if (sicon != null) sicon = "data:image/x-icon;base64,"+sicon;
		}
	} catch (err) {}
	
	var refurl = htmldoc.defaultView.document.referrer;
	
	var retval = new Object();
	retval.icon = sicon; //pass of icon to add bookmark dialog
	retval.lastBKF = HY_MostRecentWindow().hyperLastBKF;
	retval.seref = this.GetSearchReferrer(refurl);
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperAddBookmark.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable", this, htmldoc, sLoc, hypTF, bwin, retval);
	if (retval.pfol) 
	{
		HY_MostRecentWindow().hyperUsedBK = true;
		HY_MostRecentWindow().hyperLastBKF = retval.pfol;
	}
	
	this.regenBF();
	this.LoadURLs();
	
	//if (window.hyperSidebarTree) window.hyperSidebarTree.builder.rebuild();
	if (retval.pfolnode) this.BKFLimit(retval.pfolnode);
}

Hyper.BookmarkHere = function(loc)
{
	loc = loc.replace(/^\s*|\s*$/g,"");
	var htmldoc = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument;
  var hypTF = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument.hyperTF;
	
	var bfolder = this.bookDS.getNode(loc); //get parent
	var redtitle = htmldoc.title; //TODO must reduce title here.......
	if (redtitle == "") redtitle = htmldoc.URL;
	else
	{
		//reduce bookmark name automatically (if set in preferences)
		if (prefs.getBoolPref("extensions.hyper.reduceBKName"))
			redtitle = HypCommon.reduceBookmarkName(htmldoc.title);
	}
		
	var bkuri = htmldoc.URL;
	var bookmark = this.bookDS.getNode("NC:"+bkuri);
	
	var bkcf = HypCommon.BKCheckPresent(bookmark, bfolder); //check if already is present TODO
	
	bfolder.addChild(bookmark);
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Name", redtitle);
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#URL", htmldoc.URL);
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Page", htmldoc.title);
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#VisitCount", "1");
	
	var sicon = null;
	try {
		var icon = null;
		var rooturl = "";
		try{
			rooturl = htmldoc.URL;
			var endslash = rooturl.indexOf('/', 9)
			if (endslash > 0) rooturl = rooturl.substring(0, endslash);
			if (rooturl.charAt(rooturl.length-1) == '/')
				icon = rooturl + "favicon.ico";
			else
				icon = rooturl + "/favicon.ico";
		} 
		catch (err) 
		{ 
			this.dump.logStringMessage("favicon " +err.message);
			rooturl = ""; 
		}
		
		if (rooturl == "")
		{
			icon = HY_MostRecentWindow().getBrowser().selectedBrowser.mIconURL;
		}
		
		if (icon != "") 
		{
			sicon = HypCommon.readExif(icon); //read exif data
			if (sicon != null) sicon = "data:image/x-icon;base64,"+sicon;
		}
	} catch (err) {}
	if (sicon != null) bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", sicon); ///icon
	else bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", "chrome://hyper/content/images/file.png");

	var s = HypCommon.dateToStr(new Date(), false);
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", s);
	bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#LastVisitDate", s); //set last visit date as add bookmark date
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", HypCommon.getKeylist(hypTF, 0));
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#OrigKeywords", HypCommon.getKeylist(hypTF, 2));
	
	var refurl = htmldoc.defaultView.document.referrer;
	var sref = this.GetSearchReferrer(refurl); 
	if (sref != null) bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Referrer", sref);
	
	if (bkcf) //delete cache
	{
		var cachep = bookmark.getTarget("http://home.netscape.com/NC-rdf#ShortcutURL");
		var cachefp = bookmark.getTarget("http://home.netscape.com/NC-rdf#Image");
		HypCommon.BKDelCache(cachefp, cachep);
	}
	
	var cachepath = HypCommon.saveHTMLCache(this, htmldoc); //save html doc to cache
	var cpath = "file://" + HypCommon.userHome("hyperCache", cachepath+".html");
	cpath = cpath.replace(/\s/g, "%20");
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#ShortcutURL", cpath);
		
	HY_MostRecentWindow().hyperLastBKF = loc; //store uri of last bookmarked location
	HY_MostRecentWindow().hyperUsedBK = true;
	
	this.regenBF();
	this.LoadURLs();
	
	//saving of thumbnail
  var cwin = HY_MostRecentWindow().getBrowser().selectedBrowser.contentWindow;
  HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperThumbnail.xul", "" , "chrome,dialog=no,height=180,width=150", cwin, htmldoc, bookmark);
	
	//setTimeout(function () { delayISave(htmldoc, cachepath); }, 3000);

	this.BKFLimit(bfolder);
}


Hyper.UpdateBK = function(hypTF, htmldoc) //update bookmark in case that htmldoc is bookmark
{
	var bkurl = htmldoc.location.href;
	var bookmark = null;
	var bks = this.bookDS.getAllResources();
	while (bks.hasMoreElements()) //find bookmark by URL
	{
		try {
			var bk = bks.getNext();
			if (!bk.isContainer())
			{
				var st = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
				if (st.getValue() == bkurl)
				{			
					bookmark = bk;
					break;
				}
			}
		} catch (err) { this.dump.logStringMessage("Bookmark Update FindBK Failed " +err.message); }
	}
	if (bookmark == null) 
  {
    this.dump.logStringMessage("UpdateBK Bookmark Not Found " + bkurl);
    return;
  }
	
	var stat = HypCommon.HYcheckStatus(htmldoc);
	if ((stat == "offline") || (stat == "notfound")) return; //if failed to load do not update anything!!!
	
	if (hypTF != null)
	{
		bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", HypCommon.getKeylist(hypTF, 0));
		bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#OrigKeywords", HypCommon.getKeylist(hypTF, 2));
	}
	if (htmldoc.title != null) bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Page", htmldoc.title);
	
	//Should Thumbnail be updated? -- every 14days or (randomly)
	var updateBKThumb = false;
	var lvisd = bookmark.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
	if (lvisd != null)
	{
		lvisd = lvisd.getValue();
		if (lvisd != "") 
		{
			var lvisdate = HypCommon.sDateConv(lvisd);
			var todaydate = new Date();
			todaydate.setDate(todaydate.getDate()-14); //visited 14 days ago
			if (lvisdate <= todaydate)
			{
				updateBKThumb = true;
			} else if (Math.floor(Math.random() * 20) == 10) updateBKThumb = true;//randomly
		}
		else updateBKThumb = true;
	} else updateBKThumb = true; //update because no last visit date
	
	try {
		//update page cache
		HypCommon.updateHTMLCache(this, htmldoc, bookmark);
		//update page thumbnail -- for now only when no thumbnail exist, every 14days or randomly
		var tempP = bookmark.getTarget("http://home.netscape.com/NC-rdf#Image");
		if (tempP != null) tempP = tempP.getValue();
		if ((tempP == null) || (tempP == "") || (updateBKThumb == true))
		{
			var cwin = HY_MostRecentWindow().getBrowser().selectedBrowser.contentWindow;
      HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperThumbnail.xul", "" , "chrome,dialog=no,height=180,width=150", cwin, htmldoc, bookmark);
		}
	} catch (err) 
	{
		this.dump.logStringMessage("Bookmark Cache/Thumbnail Update Failed " +err);
	}
	
	//update last visit date
	var visdate = new Date();
	var month = visdate.getMonth() + 1;
	var dt = visdate.getDate() + '|' + month + '|' + visdate.getFullYear();
	bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#LastVisitDate", dt);	
	//increment visit count
	var viscount = bookmark.getTarget("http://home.netscape.com/NC-rdf#VisitCount");
	var vcnt = 0;
	if (viscount != null) vcnt = viscount.getValue();
	if ((vcnt == "") || (vcnt == null)) vcnt = 0;
	vcnt = parseInt(vcnt);
	vcnt = vcnt +1;
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#VisitCount", vcnt + "");
			
	try {
		//var icon = document.getElementById("page-proxy-favicon"); //get icon
		//if ((icon.src != "") && (icon.src.indexOf(bkurl) != -1))  //icon.src below
		
		var icon = "";
    		var rooturl = "";
		try{
			rooturl = htmldoc.URL; //htmldoc.location.href; //htmldoc.URL;
			var endslash = rooturl.indexOf('/', 9)
			if (endslash > 0) rooturl = rooturl.substring(0, endslash);
			if (rooturl.charAt(rooturl.length-1) == '/')
				icon = rooturl + "favicon.ico";
			else
				icon = rooturl + "/favicon.ico";
		} 
		catch (err) 
		{ 
			this.dump.logStringMessage("favicon error " +err);
			icon = ""; 
		}
		//this.dump.logStringMessage("favicon " +icon);		
		
		if (icon == "")
		  icon = HY_MostRecentWindow().getBrowser().selectedBrowser.mIconURL;
		
		if (icon != "")
		{
			var sicon = HypCommon.readExif(icon); //read exif data
			if (sicon != null) 
			{
				sicon = "data:image/x-icon;base64,"+sicon;
				bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", sicon); ///icon
			}
		}
	} catch (err) { this.dump.logStringMessage("Bookmark favicon Update Failed " +err); }
}

Hyper.BookmarkTour = function(loc, tc)
{
	loc = loc.replace(/^\s*|\s*$/g,"");
	var parnode = this.bookDS.getNode(loc);
	this.Tour = new Array();
	this.TourCount = -1;
	var t = parnode.getChildren();
	while (t.hasMoreElements())
	{
		var x = t.getNext();
		if ((tc != null) && (x.getValue() == tc)) this.TourCount = this.Tour.length-1;
		if (!x.isContainer()) this.Tour[this.Tour.length] = x;
	}
	this.TourNext(1);
}

Hyper.TourNext = function(p) //move tour to next p : +1/-1
{
	if (this.Tour == null)
	{
		var result = new Object();
		HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperSelectFolder.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable", this, result, HypCommon.getString("SELECT_CAT_TOUR"));
		if (result.res == null) return; 
		var nname = result.res;
		this.BookmarkTour(nname, null);
	}
	else
	{
		this.TourCount = this.TourCount + p;
		if (this.TourCount < 0) this.TourCount = this.Tour.length-1;
		if (this.TourCount >= this.Tour.length) this.TourCount = 0;
		var bnode = this.Tour[this.TourCount];
		
		this.OpenBK(bnode);
	}
}

Hyper.BKSeeAlso = function(loc) //which See Also Algorithm to Use
{
	var algo = prefs.getIntPref("extensions.hyper.bkalsoalgo");
	switch (algo)
	{
		case 1 : this.BKSeeAlso1(loc); break;
		case 2 : this.BKSeeAlso2(loc); break;
		default : this.BKSeeAlso1(loc); break;
	}
}

function getTopSearchKW(keyarr2, tnum) //out of keyarr2....return tnum of terms as a string
{
	//construct new array from array of strings to array of arrays with [0] stemmed keyterm, [1] as count and [2] as original keyworld
	var keysa = new Array();
	for(var i=0; i<keyarr2.length; i++)
	{
		if (keyarr2[i] != "")
			keysa[keysa.length] = new Array(stemWord(keyarr2[i]), 1, keyarr2[i]);
	}
		
	for(var i=0; i<keysa.length; i++)
	{
		if (keysa[i][0] != "")
		for(var j=0; j<keysa.length; j++)
		{
			if ((i != j) && (keysa[i][0] == keysa[j][0]))
			{
				keysa[j][0] = "";
				keysa[j][1] = 0;
				keysa[i][1] = keysa[i][1] +1; //compute term freq
			}
		}
	}
		
	keysa.sort(HYsortwords); //sort in descending order
		
	var q = "";
	for(var i=0; ((i<keysa.length) && (i<tnum)); i++)
	{
		if (keysa[i][1] > 1) q = q + " " + keysa[i][2]; //must be present more than once
	}
	
	try { 
	   if (q == "") q = keysa[0][2] + " " + keysa[1][2]; //in case nothing is retrieved
	} catch (err) {
		q = keysa[0][2]; //in case one element
	}
	
	return q;
}

Hyper.BKSeeAlso1 = function(loc) //using automatic fetched terms from pages
{
	var keyarr2 = new Array();
	loc = loc.replace(/^\s*|\s*$/g,"");
	var pfol = this.bookDS.getNode(loc);
	if (pfol.getChildCount() <= 0) return; //in case of empty folder
	
	var bks = pfol.getChildren();
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (!bk.isContainer())
		{
			var sta2 = bk.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
			if (sta2 != null)
			{
				sta2 = sta2.getValue();
				if (sta2 != "")
				{
					sta2 = sta2.split(";");
					keyarr2 = keyarr2.concat(sta2);
				}
			}
		}
	}
	
	if (keyarr2.length == 0)
	{
		alert(HypCommon.getString("NO_KEYWORDS"));
		return;
	}
	
	var q = getTopSearchKW(keyarr2, 4);
	if (q == "")
	{
		alert(HypCommon.getString("FAILED_NO_BK")); return;
	}
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperGSearch3.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=400,width=800", HypCommon.getString("SEE_ALSO"), HypCommon.getString("BK_SEE_ALSO"), q, HY_OpenTab);
}

//UPDATED USING GOOGLE DIRECTORY TOO
Hyper.BKSeeAlso2 = function(loc) //using SE Referrer
{
	loc = loc.replace(/^\s*|\s*$/g,"");
	var pfol = this.bookDS.getNode(loc);
	if (pfol.getChildCount() <= 0) return; //in case of empty folder
	
	var qs = "";
	var se = HypCommon.getSE(prefs);
	
	var bks = pfol.getChildren();
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (!bk.isContainer())
		{
			var sta2 = bk.getTarget("http://home.netscape.com/NC-rdf#Referrer");
			if (sta2 != null)
			{
				sta2 = sta2.getValue();
				var qi = HypCommon.seURL(se, sta2);
				if (qi > -1)
				{
					var qvlen = se[qi][1].length + 1;
					var spos = sta2.indexOf(se[qi][1]+"=");
					var epos = sta2.indexOf("&", spos);
					var s = sta2.substring(spos + qvlen, epos);
					s = s.replace(/%20/g, " ");
					qs = qs + s.replace(/\+/g, " ") + " ";
				}
			}
		}
	}
	if (qs == "")
	{
		if (confirm(HypCommon.getString("NO_SE_USEALT")))
			this.BKSeeAlso1(loc);
	}
	else
	{
		var keyarr2 = qs.split(" ");
		var q = getTopSearchKW(keyarr2, 4);
		HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperGSearch3.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=400,width=800", HypCommon.getString("SEE_ALSO"), HypCommon.getString("BK_SEE_ALSO"), q, HY_OpenTab);
	}
}

Hyper.BKIManager = function() //bookmark manager with thumbs
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperBManager.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=400,width=800", this);
}

Hyper.BookmarkList = function() //simple bookmark manager
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperBookmarkList.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=300,width=800", this);
}

Hyper.HistoryList = function() //history window
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperHist.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=300,width=800", this, HY_OpenTab);
}

Hyper.BookmarkCheck = function() //verify bookmarks window
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperVerifyBookmark.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=300,width=800", this);
}

Hyper.OpenBK = function(s, tb) //open bookmark in active browser window
{
	var locnode;
	//if (s.type == "Node") //in case passed variable is already the required node
	if (typeof s == "object") //TODO need to test if ok...
	{
		locnode = s;
	}
	else
	{ //instead it is just the uri to the node
		s = s.replace(/^\s*|\s*$/g,"");
		locnode = this.bookDS.getNode(s);
	}
	var locurl = locnode.getTarget("http://home.netscape.com/NC-rdf#URL");
	//debug(s)
  //debug(locurl.getValue())
  HY_MostRecentWindow().hyperNowOpenBK = s;
  HY_MostRecentWindow().hyperNowOpenURL = locurl.getValue();

	HY_OpenNewDoc(locurl.getValue(), tb);
}

function HY_MostRecentWindow() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
               getService(Components.interfaces.nsIWindowMediator);
    var thisWin = wm.getMostRecentWindow("navigator:browser");
    
    if (!thisWin) { thisWin = wm.getMostRecentWindow("emusic:window"); }

    return thisWin;
}


function HY_OpenNewDoc(s, tb)
{
	if (tb == null)
	{
		tb = true;
	}
	else {
		if (prefs.getBoolPref("extensions.hyper.openAlwaysNewTab")) tb = true; //To Open Always in New TAB

    var thisWindow = HY_MostRecentWindow()
		var htmldoc = thisWindow.getBrowser().selectedBrowser.contentDocument;

		if (htmldoc.URL == "about:blank") tb = false;
	}
	
	if (tb)
		HY_OpenTab(s);
	else
		thisWindow.loadURI(s);
}

Hyper.OpenBKClickMenu = function(e, node)
{
	if (e.button == 0)
		Hyper.OpenBK(node, false);
	else if (e.button == 1)
	{
		var bkmenu = HY_MostRecentWindow().document.getElementById("menu_newBookmarksPopup");
		bkmenu.hidePopup();
		Hyper.OpenBK(node, true);
	}
}

Hyper.OpenBKTabs = function(fol)
{
	if (!fol.isContainer()) return;
	var i=0;
	var bks = fol.getChildren();
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (bk.isContainer()) continue; //folders SKIP
		i++;
		if ((i == 1) && (HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument.URL == "about:blank"))
			this.OpenBK(bk, false); //not in new tab
		else
			this.OpenBK(bk, null); //FIX!!!
		if (i > 14) return; //safe measure ...although 14 bookmarks r too much
	}
}

Hyper.OpenBKCache = function(s, tb) //open bookmark from local cache
{
	var locnode;
	//if (s.type == "Node") //in case passed variable is already the required node
	if (typeof s == "object") //TODO need to test if ok...
		locnode = s;
	else
	{ //instead it is just the uri to the node
		s = s.replace(/^\s*|\s*$/g,"");
		locnode = this.bookDS.getNode(s);
	}
	var locurl = locnode.getTarget("http://home.netscape.com/NC-rdf#ShortcutURL");
	
	//if (prefs.getBoolPref("extensions.hyper.openAlwaysNewTab")) tb = true; //To Open Always in New TAB
	
	if (tb)
	{
		//var t = window.getBrowser().addTab(locurl.getValue());
		//window.getBrowser().selectedTab = t;
		HY_MostRecentWindow().loadURI(locurl.getValue());
	}
	else
		HY_MostRecentWindow().loadURI(locurl.getValue());
}

Hyper.SaveDoc = function(htmldom, lpath) //save htmldoc to disk
{
	var webPersist = Components.interfaces.nsIWebBrowserPersist;
	
	if (lpath == null) lpath = HypCommon.randomString(); //might be more suitable to prompt....
	
	var filep = HypCommon.userHome("hyperCache", lpath+".html");
	var datap = HypCommon.userHome("hyperCache", lpath+"_data");
	
	var htmldoc;
	if (htmldom == null)
		htmldoc = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument;
	else 
		htmldoc = htmldom; //in case passed as paramter
	
	htmldoc = htmldoc.defaultView.document;
	
	var bper = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
	var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	var dataPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	
	localFile.initWithPath(filep);
	dataPath.initWithPath(datap);
	
	bper.persistFlags = webPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
	bper.persistFlags |= webPersist.PERSIST_FLAGS_FROM_CACHE;
	bper.persistFlags |= webPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
	
	var encf = 0;
	if (htmldoc.contentType == "text/plain")
	{
		encf |= webPersist.ENCODE_FLAGS_FORMATTED;
		encf |= webPersist.ENCODE_FLAGS_ABSOLUTE_LINKS;
		encf |= webPersist.ENCODE_FLAGS_NOFRAMES_CONTENT;
	}
	else
		encf |= webPersist.ENCODE_FLAGS_ENCODE_BASIC_ENTITIES;
	
	bper.progressListener = null;
	
	try
	{
		var ret = bper.saveDocument(htmldoc, localFile, dataPath, htmldoc.contentType, encf, 100);
	}
	catch (err)
	{
		this.dump.logStringMessage("Bookmark Cache "+htmldoc.URL+" to Cache "+lpath+" Failed\r\n"+err.message);
	}
}

Hyper.matchBF = function(pagekwords) //returns array with [0] section and [1] hit count
{
	var bkmatches = new Array();
	for(var i=0; i<this.keywordsBF.length; i++)
	{
		var kbf = this.keywordsBF[i][1].split(";");
		var bkmatch = 0;
		for(var j=0; j<kbf.length; j++)
		{
			for(var k=0; k<pagekwords.length; k++)
			{
				if (pagekwords[k][0] == kbf[j]) bkmatch++;
			}
		}
		
		bkmatches[bkmatches.length] = new Array(this.keywordsBF[i][0], bkmatch);
	}
	bkmatches.sort(HYsortwords);
	
	return bkmatches;
}

Hyper.FastBookmark = function(htmldoc, getfavicon) //add a link to the fast bookmarks
{
	var maxn = prefs.getIntPref("extensions.hyper.maxfastbk");
	if (htmldoc == null) htmldoc = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument;
	var hypTF = htmldoc.hyperTF;
	
	var bkuri = htmldoc.URL;
	
	var par = this.fastbkDS.getNode("NC:FastBKRoot");
	if (par.getChildCount() >= maxn) 
	{
		while (par.getChildCount() >= maxn)
		{
			var x = this.fastbkDS.getChildAt(0);
			this.fastbkDS.deleteRecursive(x);
		}
	}
	
	//now get child and add
	var fbk = this.fastbkDS.getNode("NC:"+bkuri);
	par.addChild(fbk);
	var bname = HypCommon.reduceBookmarkName(htmldoc.title); //automatically reduce bookmark name?
	fbk.addTargetOnce("http://home.netscape.com/NC-rdf#Name",bname);
	fbk.addTargetOnce("http://home.netscape.com/NC-rdf#URL", htmldoc.URL);
	fbk.addTargetOnce("http://home.netscape.com/NC-rdf#Page", htmldoc.title);
	fbk.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", HypCommon.getKeylist(hypTF, 0));
	fbk.addTargetOnce("http://home.netscape.com/NC-rdf#OrigKeywords", HypCommon.getKeylist(hypTF, 2));
	
	var createdate = new Date();
	var month = createdate.getMonth() + 1;
	var s = createdate.getDate() + '|' + month + '|' + createdate.getFullYear();
	fbk.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", s);
	
	var icon = document.getElementById("page-proxy-favicon"); //get icon
	var sicon = null;
	if (getfavicon == null) //for bookmark all tabs ...problematic TODO
	if (icon.src != "") 
	{
		sicon = HypCommon.readExif(icon.src); //read exif data
		if (sicon != null) sicon = "data:image/x-icon;base64,"+sicon;
	}
	if (sicon != null) fbk.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", sicon); ///icon
	else fbk.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", "chrome://hyper/content/images/file.png");
	
	this.fastbkDS.save();
}

Hyper.OpenFBK = function(s, tb) //open fast bookmark
{
	var locnode;
	if (s.type == "Node") //in case passed variable is already the required node
		locnode = s;
	else
	{ //instead it is just the uri to the node
		s = s.replace(/^\s*|\s*$/g,"");
		locnode = this.fastbkDS.getNode(s);
	}
	var locurl = locnode.getTarget("http://home.netscape.com/NC-rdf#URL");
	
	HY_OpenNewDoc(locurl.getValue(), tb);
}

Hyper.OpenFBKClickMenu = function(e, node)
{
	if (e.button == 0)
		Hyper.OpenFBK(node, false);
	else if (e.button == 1)
	{
		try {
			var fbkmenu = HY_MostRecentWindow().document.getElementById("menu_fastBookmarksPopup");
			fbkmenu.hidePopup();
		} catch (err) { }
		try {
			var tfbkmenu = HY_MostRecentWindow().document.getElementById("menu_TfastBookmarksPopup");
			tfbkmenu.hidePopup();
		} catch (err) { }
		Hyper.OpenFBK(node, true);
	}
}

Hyper.BookmarkAllTabs = function() //bookmark all open tabs to fast bookmarks
{
	var brows = HY_MostRecentWindow().getBrowser().browsers;
	for(var i=0; i<brows.length; i++)
	{
		this.FastBookmark(brows[i].contentDocument, true);
	}
	alert(HypCommon.getString("BK_ALL_TABS"));
}

Hyper.ClearFBK = function() //clear fast bookmarks
{
	if (!confirm(HypCommon.getString("SURE_DEL_FBK"))) return;
	
	var par = this.fastbkDS.getNode("NC:FastBKRoot");
	var childs = par.getChildren();
	while (childs.hasMoreElements())
	{
		var child = childs.getNext();
		this.fastbkDS.deleteRecursive(child);
	}
	this.fastbkDS.save();
}

Hyper.DeleteFBK = function(s)
{
	var locnode;
	if (s.type == "Node") //in case passed variable is already the required node
		locnode = s;
	else
	{ //instead it is just the uri to the node
		s = s.replace(/^\s*|\s*$/g,"");
		locnode = this.fastbkDS.getNode(s);
	}
	
	this.fastbkDS.deleteRecursive(locnode);
	this.fastbkDS.save();
}

Hyper.MailLink = function() //prompt for email address, and construct email
{
	var email = prompt(HypCommon.getString("ENTER_EML")); //or should be left to mail client...
	
	var htmldoc = HY_MostRecentWindow().getBrowser().selectedBrowser.contentDocument;
	
	if (!email.match(/\b(^(\S+@).+((\.com)|(\.net)|(\.edu)|(\.mil)|(\.gov)|(\.org)|(\..{2,2}))$)\b/gi))
	{
		alert(HypCommon.getString("ENTER_VALID"));
		return;
	}
	
	var nw = HY_MostRecentWindow().open("mailto:"+email+"?subject=HyperBK "+HypCommon.getString("EMAIL_SUGG")+" "+escape(htmldoc.URL)+"&body="+HypCommon.getString("EMAIL_INTEREST")+", Title: "+escape(htmldoc.title)+" URL: "+escape(htmldoc.URL));
	nw.close();
}

Hyper.BKFLimit = function(f) //to check that bookmark folder does not exeeds limit, if yes open limit wizard
{
	if (!f.isContainer()) return false; //is not container do nothing
	var maxbks = prefs.getIntPref("extensions.hyper.maxBKsF");
	if (maxbks <= 0) return false; //disabled limit wizard
	if (f.getValue() == "NC:BookmarksRoot") return false; //disabled for root!!
	if (f.getChildCount() <= maxbks) return false; //less than limit do nothing
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperLimitBKW.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,height=600,width=800", this, f);
	
	return true;
}

Hyper.Preferences = function()
{
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperPreferences.xul");
}

Hyper.RetrieveBK = function(node) //pops out google search to search for dead bookmark
{
	var q = "";
	try { 
		var ptit = node.getTarget("http://home.netscape.com/NC-rdf#Page");
		q = "intitle:\""+ptit.getValue() + "\""; //and if more than one word in title??? / or no title?
		var keywords = node.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
		keywords = keywords.getValue();
		keywords = keywords.replace(/;/g, " ");
		q = q + " " + keywords;
	} catch (err) { this.dump.logStringMessage("Retrieve BK Failed " +err); }
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperGSearch3.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=400,width=800", HypCommon.getString("REFIND_BK"), HypCommon.getString("BK_RELOC"), q, HY_OpenTab, "googlemain");
}

Hyper.FFullTour = function() //first full bookmark tour
{
	if (!confirm(HypCommon.getString("SURE_TOUR_ALL"))) return;
	
	//window.hyperFullTour = true;
	prefs.setBoolPref("extensions.hyper.fbktour", true);
	prefs.setIntPref("permissions.default.image", 2); //do not load images .....faster
	this.fullTour = this.bookDS.getAllResources();
	while (this.fullTour.hasMoreElements())
	{
		var bk = this.fullTour.getNext();
		if (!bk.isContainer())
		{
			this.OpenBK(bk);
			break;
		}
	}
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperStopTour.xul", "" , "centerscreen,chrome,dialog=no,resizable=yes,height=150,width=150");
}

Hyper.TopVisited = function() //compute most 10 visited bookmarks
{
	var bkarr = new Array();
	var bks = this.bookDS.getAllResources();
	while (bks.hasMoreElements()) 
	{
		var bk = bks.getNext();
		if (!bk.isContainer()) bkarr[bkarr.length] = bk; //to array
	}
	bkarr.sort(HypCommon.bkvcsortswap);
	
	this.topBKDS = new RDFDataSource();
	var troot = this.topBKDS.getNode("NC:TopBKRoot");
	troot.makeSeq();
	for(var i=0; (i<bkarr.length) && (i<10); i++)
	{
		var name = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#Name");
		var url = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#URL");
		var icon = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#Icon");
		
		var tbk = this.topBKDS.getNode(bkarr[i].getValue());
		tbk.addTarget("http://home.netscape.com/NC-rdf#Name", name.getValue());
		tbk.addTarget("http://home.netscape.com/NC-rdf#URL", url.getValue());
		if (icon != null) tbk.addTarget("http://home.netscape.com/NC-rdf#Icon", icon.getValue());
		troot.addChild(tbk);
	}
}

Hyper.GetSearchReferrer = function(refurl) //return search referrer if available
{
	var deep = 0;
	var se = HypCommon.getSE(prefs);
	var reff = refurl;
	if (reff == "") return null; //page followed by entering url or from bookmark...
	
	while (HypCommon.seURL(se, reff) == -1) //not found
	{
	    try
	    {
		deep++;
		var refn = this.histDS.getNode(reff); //refurl
		var rfl = refn.getTarget("http://home.netscape.com/NC-rdf#Referrer");
		if (rfl != null) reff = rfl.getValue();
		else return null;
		
		if (reff == "") return null;
		if (deep > 15) return null; //too deep to consider that search page was relevant
	    }
	    catch (err) { return null; }
	}
	
	return reff;
}

Hyper.openNewTab = function(uri)
{
	HY_OpenTab(uri);
}

Hyper.open3Mess = function(titm, mess, btn)
{
	var retobj = new Object();
	retobj.ret = "";
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyper3Dialog.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable", titm, mess, btn, retobj);
	return retobj.ret;
}
///////////////////
var HyperCM = new Object();

HyperCM.CMBKOpen = function() { 
	var stid = document.popupNode.id;
	this.CMClose();
	Hyper.OpenBK(stid, false); 
}
HyperCM.CMBKOpenTab = function() { 
	var stid = document.popupNode.id;
	this.CMClose();
	Hyper.OpenBK(stid, true);  
} 
HyperCM.CMBKTabs = function() {
	var stid = document.popupNode.id;
	this.CMClose();
	var node = Hyper.bookDS.getNode(stid);
	Hyper.OpenBKTabs(node);
}
HyperCM.CMBKRename = function() { 
	var stid = document.popupNode.id;
	this.CMClose();
	HypCommon.BKRename(stid, Hyper.bookDS, Hyper.histDS);
}
HyperCM.CMBKDelete = function() { 
	var stid = document.popupNode.id;
	this.CMClose();
	if (confirm(HypCommon.getString("SURE_DELBK")) == false) return;
	HypCommon.BKDelete(stid, Hyper.bookDS, Hyper.histDS);
}
HyperCM.CMBKSort = function() {
	var stid = document.popupNode.id;
	this.CMClose();
	var parfolder = HypCommon.BKgetParent(Hyper.bookDS.getNode(stid));
	HypCommon.BKSortFolder(Hyper.bookDS, parfolder);
}
HyperCM.CMBKProp = function() {
	var stid = document.popupNode.id;
	this.CMClose();
	HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperBKProp.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable,height=200,width=450", stid, Hyper.bookDS);
}
HyperCM.CMBKCopy = function() {
	var stid = document.popupNode.id;
	this.CMClose();
	var copynode = Hyper.bookDS.getNode(stid);
	var copytext = copynode.getTarget("http://home.netscape.com/NC-rdf#URL").getValue();
	HypCommon.clipBoard(copytext);
}

HyperCM.CMClose = function()
{
	var bkmenu = HY_MostRecentWindow().document.getElementById("menu_newBookmarksPopup");
	bkmenu.hidePopup();
	var appcontent = HY_MostRecentWindow().document.getElementById("appcontent");
	appcontent.focus();
}


var HyperFBKCM = new Object();

HyperFBKCM.FBKOpen = function()
{ 
	var stid = document.popupNode.id;
	this.FBKCMClose();	
	Hyper.OpenFBK(stid, false); 
}
HyperFBKCM.FBKOpenTab = function()
{
	var stid = document.popupNode.id;
	this.FBKCMClose();
	Hyper.OpenFBK(stid, true); 
}
HyperFBKCM.FBKCopy = function()
{
	var stid = document.popupNode.id;
	this.FBKCMClose();
	var copynode = Hyper.fastbkDS.getNode(stid);
	var copytext = copynode.getTarget("http://home.netscape.com/NC-rdf#URL").getValue();
	HypCommon.clipBoard(copytext);
}
HyperFBKCM.FBKDelete = function()
{
	var stid = document.popupNode.id;
	this.FBKCMClose();
	Hyper.DeleteFBK(stid); 
}
HyperFBKCM.FBKCMClose = function()
{
	try { 
		var fbkmenu = HY_MostRecentWindow().document.getElementById("menu_fastBookmarksPopup");
		fbkmenu.hidePopup();
	} catch (err) { }
	try {
		var tfbkmenu = HY_MostRecentWindow().document.getElementById("menu_TfastBookmarksPopup");
		tfbkmenu.hidePopup();
	} catch (err) { }
	var appcontent = HY_MostRecentWindow().document.getElementById("appcontent");
	appcontent.focus();
}



///////////////
function BookmarkThisTab() //overrides the original Function
{
	var tab = getBrowser().mContextTab;
	HY_MostRecentWindow().getBrowser().selectedTab = tab;

	Hyper.Bookmark();
}
function HY_OpenTab(uri)
{
	var t = HY_MostRecentWindow().getBrowser().addTab(uri);
  HY_MostRecentWindow().getBrowser().selectedTab = t;
}

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);


function bkLink() //a bit fuzzy but works ...continues in page observer
{	
	var s = gContextMenu.getLinkURL();
	HY_MostRecentWindow().hyperToBookmark = s; //to alert page observer
  HY_MostRecentWindow().loadURI(s);
}

function HYgetInText(chdrn) //traverse DOM recursively collecting #text nodes and alt of img
{
	var s = "";
	for(var i =0; i<chdrn.length; i++)
	{
		if (chdrn[i].nodeName == "#text")
			s = s + chdrn[i].nodeValue + " ";
		else if (chdrn[i].nodeName == "IMG")
			s = s + chdrn[i].getAttribute("alt") + " ";
		else if (chdrn[i].nodeName == "SCRIPT")
			{ /*do nothing */ }
		else if (chdrn[i].nodeName == "NOSCRIPT")
			{ /*do nothing */ }
		else if (chdrn[i].nodeName == "TEXTAREA")
			{ /*do nothing */ }
		else
			s = s + HYgetInText(chdrn[i].childNodes);
	}
	
	return s;
}

function HY_stemSort(a, b)
{
	if (a[0] > b[0]) return 1;
	else return -1;
}

function HYcountwords(txt) //count words found in string txt ....remove common words
{
	var wrdsAll = txt.split(" ");
	var wrds = new Array();
	for(var i=0; i<wrdsAll.length; i++) //remove common words
	{
		if (HYcommonWord(wrdsAll[i]) == false)
		{
			wrds[wrds.length] = new Array(stemWord(wrdsAll[i]), wrdsAll[i]); //add to array stemming first, also add original
		}
	}
	
	wrds.sort(HY_stemSort); //we sort
		
	var ans = new Array();
	var score = 0;
	var acnt = 0;
	for(var i=0; i<wrds.length; i++)
	{
		if (wrds[i][0] != "")
		{
			score = 1;
					
			for(var j=i+1; j<wrds.length; j++)
			{
				if (wrds[i][0] == wrds[j][0])
				{
					wrds[j][0] = ""; //nullify
					score++;
				}
				else
					break;
			}
			
			ans[acnt] = new Array(wrds[i][0], score, wrds[i][1]);
			acnt++;
		}
	}
	return ans;	
}

function HYsortwords(a, b)
{
	return (b[1] - a[1]); //descending
}

function HY_Start(e) //page loaded....parse and gather keywords
{
	var conn = e.originalTarget;
	var twin = e.target.defaultView; //if(twin == twin.top) topmost window else iframe
	
	if (conn.body == null) return;
	
	if (HY_MostRecentWindow().hyperOpenCache != null) //means that loaded document from cache
	{
		var s = HY_MostRecentWindow().hyperOpenCache;
		var node = Hyper.bookDS.getNode(s); 
		var st = node.getTarget("http://home.netscape.com/NC-rdf#ShortcutURL");
		s = st.getValue(); s = s.replace(/\\/g, "/"); s = s.replace("//", "///"); //make it match
		if (s == twin.top.document.location.href) 
		{
			HY_MostRecentWindow().hyperOpenCache = null;
			if (confirm(HypCommon.getString("TRY_RELOC"))) 
				Hyper.RetrieveBK(node);
			return; //add now.....
		}
	}
	else if (Hyper.fullTour == null) //not loaded from cache thus check if failed to load .... and check that loaded from bookmark
	{ //try to reload from cache if not in full tour
		var stat = HypCommon.HYcheckStatus(twin.top.document);
		if ((stat == "offline") || (stat == "notfound"))
		{
		  var s = HY_MostRecentWindow().hyperNowOpenBK;
      HY_MostRecentWindow().hyperNowOpenBK = null;
      if ((s != null) && (HY_MostRecentWindow().hyperNowOpenURL == twin.top.document.location.href))
			{
				var retmess = Hyper.open3Mess(HypCommon.getString("BOOKMARK_DOWN"), HypCommon.getString("BOOKMARK_SEEMS_DOWN"), HypCommon.getString("DELETE"));
				if (retmess == "ok")
				{
					HY_MostRecentWindow().hyperOpenCache = s;
					Hyper.OpenBKCache(s);
				}
				else if (retmess == "3rd")
				{
					if (confirm(HypCommon.getString("SURE_DELBK"))) HypCommon.BKDelete(s, Hyper.bookDS, Hyper.histDS);
				}
			}
			HY_MostRecentWindow().hyperNowOpenURL = null;
			return;
		}
		HY_MostRecentWindow().hyperNowOpenBK = null;
    HY_MostRecentWindow().hyperNowOpenURL = null;
	}
	
	//get keywords in meta tags
	var metas = conn.defaultView.document.getElementsByTagName("META");
	var metakeywords = null;
	var smk = "";
	if(metas != null)
	{
		for (var i=0; i<metas.length; i++)
	   	{
			if (metas[i].getAttribute("name") == "keywords")
			{
				smk = metas[i].getAttribute("content");
				metakeywords = smk.split(",");
				for(var j=0; j<metakeywords.length; j++) metakeywords[j] = stemWord(metakeywords[j]);
				break;
			}
	   	}
	}
	
	var bodyText = HYgetInText(conn.body.childNodes);
	bodyText = bodyText.replace(/\s+/g , " "); //compres multiple spaces into 1
		
	var inText = conn.title + " " + smk + bodyText;
	inText = inText.replace(/[^A-Z|a-z]+/g , " "); //remove all chars except letters
	if (inText.length > 35000) inText = inText.substr(0, 35000); //reduce size of string in case tooo large
	inText = inText.toLowerCase();
	var tf = HYcountwords(inText); //[0] word, [1] term frequency, [2] orig word
	tf.sort(HYsortwords);
	if (tf.length > 30) tf.splice(30, tf.length-30);//reduce array size..save mem
	
	var mtf = 0;
	for(var i=0; i<tf.length; i++)
	{
		if (tf[i][1] > 1) mtf++; //count number of words that appear more than once
		else break;
	}
	if (mtf == 0) return; //no words
	if ((twin != twin.top) && (mtf <= 2)) return; //if frame (not topmost) and only 2 words return;
	
	//boost terms that occur in meta keywords
	if (metakeywords != null)
	{
		var boost = tf[0][1] - 10; 
		if (boost <= 0) boost = 5; //how much to boost...max - 10
		for(var i=0; i<tf.length; i++)
		{
			for(var j=0; j<metakeywords.length; j++)
			{
				if (metakeywords[j] == tf[i][0])
				{
					tf[i][1] = tf[i][1]+boost; //boost to top
				}
			}
		}
		tf.sort(HYsortwords); //re-sort
	}
	
	//take top 5 or 'less'
	var rtf = new Array();
	for(var i=0; (i<mtf/2) && (i<5); i++) rtf[i] = tf[i];
	
	//store inside document itself....taking care that not already present
	if (!twin.top.document.hyperTF)
	{
		twin.top.document.hyperTF = rtf;
	}
	else
	{
		var oldrtf = twin.top.document.hyperTF;
		oldrtf = oldrtf.concat(rtf); //merge into 1
		for(var x=0; x<oldrtf.length; x++) //incase of duplicates
		for(var y=0; y<oldrtf.length; y++)
		{
			if ((x != y) && (oldrtf[x][0] == oldrtf[y][0]))
			{
				oldrtf[x][1] = oldrtf[x][1] + oldrtf[y][1]; //term frequency
				oldrtf[y][1] = 0;
			}
		}
		oldrtf.sort(HYsortwords);
		if (oldrtf.length > 5) oldrtf.splice(5, oldrtf.length-5);
		twin.top.document.hyperTF = oldrtf;
	}
	
	var bkmatches = Hyper.matchBF(rtf); //match with bookmark folder
	twin.top.document.hyperMatches = bkmatches; //store in document
}

function HYbSearchML(a, anch, left, right)
{
    var mid = 0;
    while (left <= right)
    {
        mid = Math.floor((left+right)/2);
        if (HypCommon.URLMatch(a[mid], anch) > 0)
            return mid;
        if (anch.href > a[mid])
            left = mid+1;
        else if (anch.href < a[mid])
            right = mid-1;
    }
    return -1; //not found
}

function HY_MarkLinks(e) //go through anchor of loaded page and mark some of them
{
	var conn = e.originalTarget;
	var twin = e.target.defaultView;
	//if (twin.top.document.title == "Problem loading page") return;
	if (e.originalTarget.body == null) return;
	
	var alinks = conn.getElementsByTagName("A");
	if (alinks.length == 0) return; //no links do nothing.... (myspace.com) add blog fix
	
	var temp = e.originalTarget.getElementById("hyperTooltip");
	if (temp == null)
	{
		var tooltips = e.originalTarget.createElement("script"); //first insert custom tooltip script
		tooltips.setAttribute("id", "hyperTooltip");
		//tooltips.setAttribute("src", "chrome://hyper/content/tooltip.js"); //why add tooltip text when can refer to the js file directly
		var stxt = HypCommon.getSCon("chrome://hyper/content/tooltip.js");
		tooltips.appendChild(e.originalTarget.createTextNode(stxt));
		e.originalTarget.body.appendChild(tooltips);
	}
	
	var advsugg = prefs.getBoolPref("extensions.hyper.inpagesuggestionA"); //advanced suggestion (includes- Other link on same path already bookmarked)
	
	//var alinks = conn.getElementsByTagName("A");
	
	var linkbkmsg = HypCommon.getString("LINK_ALREADY_BK");
	var othlinkbkmsg = HypCommon.getString("OTH_LINK_PATH_BK");
	
	var bkurls = Hyper.urlsBK;
	for(var i=0; i<alinks.length; i++)
	{
		if (alinks[i].hasAttribute("href"))
		{
			var j = HYbSearchML(bkurls, alinks[i], 0, bkurls.length-1);
			if (j >= 0)
			{
				var umatch = HypCommon.URLMatch(bkurls[j], alinks[i]);
				if ((umatch == 1) || ((umatch == 2) && (advsugg)))
				{
					var message = "<b>HyperBK</b><br>";
					var messurl = "<br><font size='1' color='blue'>"+bkurls[j]+"</font>";
					switch (umatch)
					{
						case 1 : message += linkbkmsg + messurl; break;
						case 2 : message += othlinkbkmsg + messurl; break;
					}
					
					if (!alinks[i].hasAttribute("hyperl"))
					{
					   if (alinks[i].hasAttribute("title"))
					   {
						var sto = alinks[i].getAttribute("title");
						alinks[i].setAttribute("title", "");
						alinks[i].setAttribute("htitle", message +"<hr size=1>"+sto);
						alinks[i].setAttribute("hyperl", "suggested");
					   }
					   else
					   {
						alinks[i].setAttribute("htitle", message);
						alinks[i].setAttribute("hyperl", "suggested");
					   }
					}
				}
			}
		} //anchor with attribte href
	}
}

function HY_Thumb(win) //draw hidden thumbnail in page **not used**
{
	var temp = win.top.document.getElementById("hyperthumb");
	if (temp != null) return; //if already present do nothing
	
	var iframe = win.top.document.createElement("div");
	iframe.setAttribute("style", "width:1px; height:1px; overflow:auto;");
	iframe.setAttribute("id", "hyperdiv");
	var canvas = win.top.document.createElement("canvas");
	canvas.setAttribute("id", "hyperthumb");
	iframe.appendChild(canvas);
	win.top.document.body.appendChild(iframe);
	HypCommon.drawThumbnail(win, canvas);
}

var HYsearchE = HypCommon.getSE(prefs);
function HY_Hist(e) //update history
{
    try
    {
	var twin = e.target.defaultView; //to be removed if switched back to observer
	
	if ((twin.top.document.hyperTF == null) || (twin.top.document.hyperTF == "")) return; //if no keywords do not categorize ??
	
	var docurl = twin.top.document.location.href;
	if (docurl.indexOf("http") != 0) return; //only log http and https websites
	var refr = twin.top.document.referrer;
	if (docurl == refr) refr = ""; //problems
	
	//not to mark twice
	if (twin != twin.top) return;
	
	var hn = Hyper.histDS.getNode(docurl);
	var alreadyPresent = hn.getTarget("http://home.netscape.com/NC-rdf#Name");
	if (alreadyPresent != null) alreadyPresent = true; else alreadyPresent = false;
	
	if (twin.top.document.title != "")
		hn.addTargetOnce("http://home.netscape.com/NC-rdf#Name", twin.top.document.title);
	else
		hn.addTargetOnce("http://home.netscape.com/NC-rdf#Name", docurl);
	hn.addTargetOnce("http://home.netscape.com/NC-rdf#URL", docurl);
	
	var s = HypCommon.dateToStr(new Date(), true);
	hn.addTargetOnce("http://home.netscape.com/WEB-rdf#LastVisitDate", s);
	var hypTF = twin.top.document.hyperTF;
	hn.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", HypCommon.getKeylist(hypTF, 0));
	hn.addTargetOnce("http://home.netscape.com/NC-rdf#OrigKeywords", HypCommon.getKeylist(hypTF, 2));
	hn.addTargetOnce("http://home.netscape.com/NC-rdf#Referrer", refr);
	
	//visit counter
	var viscount = hn.getTarget("http://home.netscape.com/NC-rdf#VisitCount");
	var vcnt = 0;
	if (viscount != null) vcnt = viscount.getValue();
	if ((vcnt == "") || (vcnt == null)) vcnt = 0;
	vcnt = parseInt(vcnt);
	vcnt = vcnt +1;
	hn.addTargetOnce("http://home.netscape.com/NC-rdf#VisitCount", vcnt + "");
	
	//insert into best match or uncategorized
	var matchesF = twin.top.document.hyperMatches;
	var sLoc = null;
	var forcast = Hyper.ForcastBKParent(docurl, matchesF, twin.top.document.title, hypTF);
	if (HypCommon.seURL(HYsearchE, docurl) >= 0) //SEARCH PAGES
	{
		sLoc = Hyper.histDS.getNode("NC:Search_Pages");
		if (!sLoc.isContainer()) //for initialization ... to be removed from here
		{
			sLoc.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("SP_DS_NAME"));
			sLoc.makeBag();
			var root = Hyper.histDS.getNode("NC:BTopRoot"); 
			root.addChild(sLoc, false);
		}
	}
	else if (forcast != null)
	{
		sLoc = Hyper.histDS.getNode(forcast);
	}
	else //add to uncategorized section
	{
		sLoc = Hyper.histDS.getNode("NC:Uncategorized");
		if (!sLoc.isContainer()) //for initialization ... to be removed from here
		{
			sLoc.addTargetOnce("http://home.netscape.com/NC-rdf#Name", HypCommon.getString("UC_DS_NAME"));
			sLoc.makeBag();
			var root = Hyper.histDS.getNode("NC:BTopRoot"); 
			root.addChild(sLoc, false);
		}
	}
	
	if (alreadyPresent)
	{ //first need to remove from existent parent
		var parhn = HypCommon.BKgetParent(hn);
		if (parhn.getValue() != sLoc.getValue()) //only remove and add if different parents
		{
			parhn.removeChild(hn);
			sLoc.addChild(hn);
		}
	}
	else
		sLoc.addChild(hn, false); //only add if not present
    }
    catch (exc) 
    { 
	Hyper.dump.logStringMessage("Hyper History Update Failed...Please repair Bookmarks and DataSource.");
    }
}

///TESTING--------------------------------------------------------------------------------------------------
function HY_liverec(bk)
{
	var ss = "";
	if (bk.childNodes != null)
	{
		for (var i=0; i<bk.childNodes.length; i++)
		{
			if (bk.childNodes[i].nodeName == "menupopup")
			{
				bk.childNodes[i].showPopup(); //makes content be generated...
				bk.childNodes[i].hidePopup();
			}
			
			if (bk.childNodes[i].hasAttribute("livemark"))
			{
				//if (bk.childNodes[i].nodeName == "menu")
				ss = ss + bk.childNodes[i].label;
				
				var lmenu = HY_MostRecentWindow().document.getElementById("hylivemarkspopup");
				lmenu.childNodes[lmenu.childNodes.length] = bk.childNodes[i];
			}
			//else if (bk.childNodes[i].nodeName == "menuitem")
			//	ss = bk.childNodes[i].label;
			
			//Hyper.dump.logStringMessage(ss);
			HY_liverec(bk.childNodes[i]);
			
		}
		//Hyper.dump.logStringMessage(ss);
	}
}

function HY_loadLivemarks()
{
	Hyper.dump.logStringMessage("start");
	var bookmarkmenu = HY_MostRecentWindow().document.getElementById("bookmarks-menu");
  var bookmarkmenupopup = HY_MostRecentWindow().document.getElementById("menu_BookmarksPopup");
  //bookmarkmenupopup.showPopup();
	//bookmarkmenupopup.hidePopup();
	HY_liverec(bookmarkmenu);
	
	Hyper.dump.logStringMessage("end");	
}
///---------------------------------------------------------------------------------------------------------

function HY_winLoaded(e)
{
	var appcontent = HY_MostRecentWindow().document.getElementById("appcontent");
	if (appcontent)
	{	
		if (!appcontent.HYfiltered) //need to check that not already modified
		{
			var newbookmarkmenu = HY_MostRecentWindow().document.getElementById("smbm");
			newbookmarkmenu.database.AddDataSource(Hyper.bookDS.getRawDataSource());
			var fastbkmenu = HY_MostRecentWindow().document.getElementById("fastbkmenu");
			fastbkmenu.database.AddDataSource(Hyper.fastbkDS.getRawDataSource());
			try
			{
				var bktoolbar = HY_MostRecentWindow().document.getElementById("capbar2");
				var refloc = prefs.getCharPref("extensions.hyper.bktoolbar")
				if (refloc != "") bktoolbar.setAttribute("ref", refloc);
				bktoolbar.database.AddDataSource(Hyper.bookDS.getRawDataSource());
				bktoolbar.builder.rebuild();
			} catch (err) { Hyper.dump.logStringMessage(err); }
			
			try {   //disable old bookmark functionality
				var kaddbk = HY_MostRecentWindow().document.getElementById("addBookmarkAsKb");
				kaddbk.setAttribute("command", "HyperAddBookmark");
			} catch (err) { }
			try {
				var ctbkpage = HY_MostRecentWindow().document.getElementById("context-bookmarkpage");
				ctbkpage.setAttribute("oncommand", "Hyper.Bookmark();");
			} catch (err) { }
			try {
				var ctbklink = HY_MostRecentWindow().document.getElementById("context-bookmarklink");
				ctbklink.setAttribute("oncommand", "bkLink();");
			} catch (err) { }
			try {
				var ktabsbk = HY_MostRecentWindow().document.getElementById("bookmarkAllTabsKb");
				ktabsbk.setAttribute("command", "HyperBookmarkAllTabs");
			} catch (err) { }
			try {
				var ksidebk = HY_MostRecentWindow().document.getElementById("viewBookmarksSidebarKb");
				ksidebk.setAttribute("command", "HyperBookmarkSidebar");
			} catch (err) { }
			try {
				var ksidewinbk = HY_MostRecentWindow().document.getElementById("viewBookmarksSidebarWinKb");
				ksidewinbk.setAttribute("command", "HyperBookmarkSidebarWin");
			} catch (err) { }
			
			try { //Remove Old Bookmark Menu
				if (prefs.getBoolPref("extensions.hyper.hideOldBKM"))
				{
					var bookmarkmenu = HY_MostRecentWindow().document.getElementById("bookmarks-menu");
					if (bookmarkmenu == null) bookmarkmenu = HY_MostRecentWindow().document.getElementById("bookmarksMenu");//Firefox v3
					bookmarkmenu.setAttribute("hidden", "true");	
				}
			} catch (err) {  }
	
			try { //new Star Button (Bookmark Button) in Firefox 3.0
				var star_but = HY_MostRecentWindow().document.getElementById("star-button");
				if (star_but != null)
				{
					star_but.setAttribute("onclick", "if (event.button == 0) Hyper.Bookmark();");
				}
			}
			catch (err) { }
	
			HY_MostRecentWindow().hyperLastBKF = prefs.getCharPref("extensions.hyper.lastSaveFolder");
			HY_MostRecentWindow().hyperObj = Hyper;
			HY_MostRecentWindow().hyperFullTour = false;
			
			try {
				var hyperNavBarBtn = HY_MostRecentWindow().document.getElementById("hyper_nav-bar");
				if (prefs.getBoolPref("extensions.hyper.navbarbtn") == false)
				{
					hyperNavBarBtn.setAttribute("hidden", "true");
				}
				else
				{
					var allnavbar = HY_MostRecentWindow().document.getElementById("nav-bar");
					var curset = allnavbar.getAttribute("currentset");
					if (curset.indexOf("hyper_nav-bar") == -1)
					{
					  allnavbar.insertItem("hyper_nav-bar", null, null, false);
					}
			        }
			} catch (err) {}
			
			try {
				var hypTopBKmenu = document.getElementById("topbkmenu");
				hypTopBKmenu.database.AddDataSource(Hyper.topBKDS.getRawDataSource()); //does not reupdate....?
				hypTopBKmenu.builder.rebuild();
			} catch (err) {}
			
			try {
				if (prefs.getBoolPref("extensions.hyper.showfbk"))
				{
					var fbookmarkmenu = HY_MostRecentWindow().document.getElementById("smfbm");
					fbookmarkmenu.setAttribute("hidden", "false");
					fbookmarkmenu.database.AddDataSource(Hyper.fastbkDS.getRawDataSource()); //does not reupdate....?
					fbookmarkmenu.builder.rebuild();
				}
			} catch (err) {}
			
			appcontent.HYfiltered = true;
			appcontent.addEventListener("DOMContentLoaded", HY_Start, true);
			if (prefs.getBoolPref("extensions.hyper.inpagesuggestion")) //offer in page tooltip suggestion
				appcontent.addEventListener("DOMContentLoaded", HY_MarkLinks, true);
			
			//below should be removed when bug of non fired observer for tab with no focus
			appcontent.addEventListener("DOMContentLoaded", HY_Hist, true);
			
			if (prefs.getBoolPref("extensions.hyper.firsttime")) //RUNS ONLY ON FIRST TIME LOAD
			{
				var returnval = new Object();
				returnval.expbk = false;
				HY_MostRecentWindow().openDialog("chrome://hyper/content/hyperWelcome.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,width=600,height=400", Hyper, returnval);
				if (returnval.expbk) appcontent.addEventListener("DOMContentLoaded", FFOrigBK, true);
			}

		}
	}
}

function FFOrigBK() //calls command to export original firefox bookmarks..runs only once (after welcome wizard)
{
	var appcontent = HY_MostRecentWindow().document.getElementById("appcontent");
	appcontent.removeEventListener("DOMContentLoaded", FFOrigBK, true);
	var obkecom = HY_MostRecentWindow().document.getElementById("OrigExpBookmarks");
	obkecom.doCommand();
}

function HY_winUnLoaded(e) //when window closed
{
	Hyper.bookDS.save(); //be sure to save bookmarks to disk
	Hyper.fastbkDS.save();
	Hyper.histDS.save();
	
	if (HY_MostRecentWindow().hyperUsedBK)
	{
		prefs.setCharPref("extensions.hyper.lastSaveFolder", HY_MostRecentWindow().hyperLastBKF)
	}
	return true;
}

/////////////////////////////////////////////////////
function HYPageObserver() 
{ 
	//alert("init"); 
}

HYPageObserver.prototype.observe = function (oSubject, sMessage, sContextUrl) //BUG: observer does not fire if doc has no focus....?
{
	//reupdate in case of bookmark
	var bkurls = Hyper.urlsBK;
	var docurl = sContextUrl;
	docurl = docurl.replace(/\/$/, "");
	if (HYbinarySearch(bkurls, docurl, 0, bkurls.length) == true) 
	{
    Hyper.UpdateBK(oSubject.top.document.hyperTF, oSubject.top.document);	
	}
	
	//Update History
	/*
	//if (sContextUrl.indexOf("http") == 0) 
		HY_Hist(oSubject);
	*/
	if (HY_MostRecentWindow().hyperToBookmark != null) //context menu right click bookmark link (problem if url changes)
	{
		if (HY_MostRecentWindow().hyperToBookmark == sContextUrl)
		{
			HY_MostRecentWindow().hyperToBookmark = null;
			Hyper.Bookmark();
		}
	}
	
	//save bookmark/history file every now and then (in case Firefox crashes)
	if (Math.floor(Math.random() * 30) == 15)
	{
		Hyper.bookDS.save();
		Hyper.histDS.save();
	}
	
	if (prefs.getBoolPref("extensions.hyper.fbktour")) //in case of tour of all bookmarks (first time only...)
	{
		if (Hyper.fullTour == null) 
		{
			prefs.setBoolPref("extensions.hyper.fbktour", false);
			prefs.setIntPref("permissions.default.image", 1);
		}
		else
		{
		    while (Hyper.fullTour.hasMoreElements())
		    {
			var bk = Hyper.fullTour.getNext();
			if (Hyper.fullTour.hasMoreElements() == false) 
			{
				prefs.setBoolPref("extensions.hyper.fbktour", false);
				prefs.setIntPref("permissions.default.image", 1); //restart loading images
				Hyper.fullTour = null;
			}
			
			if (!bk.isContainer())
			{
				var keywords = bk.getTarget("http://home.netscape.com/NC-rdf#Keywords");
				try {
					if (keywords.getValue() == "")
					{
						var url = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
						url = url.getValue();
						var edocs = new Array(".doc", ".pdf", ".ppt", ".xml", ".exl", ".exe", ".rar", ".zip"); //docs to exclude from tour
						var eflag = false;
						var tempurl = url.toLowerCase();
						var lastslash = url.lastIndexOf('/');
						for(var c=0; c<edocs.length; c++) if (tempurl.indexOf(edocs[c], lastslash) > 0) eflag = true; //excluded documents
						if ((url.indexOf("http") == 0) && (eflag == false))
						{
							Hyper.OpenBK(bk, false);
							break;
						}
					}
				} catch (err) {}
			}
		    } //while
		}	            
	}//full tour
}

var HYpobserve = new HYPageObserver();


function HYregObserver()
{
	var oObserverService = Components.classes["@mozilla.org/observer-service;1"].getService();
	oObserverService = oObserverService.QueryInterface(Components.interfaces.nsIObserverService);
	var obsE = oObserverService.enumerateObservers("EndDocumentLoad");
	var poflag = true;
	while (obsE.hasMoreElements())
	{
		var obs = obsE.getNext();
		if (obs.type == HYpobserve.type) 
		{
			poflag = false; //REGISTER ONLY ONCE
			break;
		}
	}
	if (poflag) oObserverService.addObserver(HYpobserve, "EndDocumentLoad", false);
}
/////////////////////////////////////////////////////

function HY_Init()
{
	var pathBDS = "file://"+HypCommon.userHome("", "hyperBookmarks.rdf");   //PATH TO USER BOOKMARK FILE
	var pathFDS = "file://"+HypCommon.userHome("", "hyperFastBK.rdf");
	var pathHDS = "file://"+HypCommon.userHome("", "hyperHistory.rdf");

	Hyper.OnLoad(pathBDS, pathFDS, pathHDS);
	
	//CONTENT LISTENER
	HY_MostRecentWindow().addEventListener("load", HY_winLoaded, true);
  HY_MostRecentWindow().addEventListener("close", HY_winUnLoaded, true);
	HYregObserver();
	
	try
	{
		if (Math.floor(Math.random() * 20) == 10) //randomly
		{
			Hyper.RepairDS(false);	
			Hyper.dump.logStringMessage("Checking HyperBK Bookmark File...OK");
		}
	}
	catch (err)
	{
		Hyper.dump.logStringMessage("Bookmark File Seems to be Corrupted...Seek assistance");
		Hyper.dump.logStringMessage("email a copy of hyperBookmarks.rdf to hyper@iannet.org");
		Hyper.dump.logStringMessage(err);
	}
	
	try
	{
		//Hyper.regenBF(); //recompute words that represent category by union of bookmark keywords inside category
		Hyper.FastRegenBF();
		Hyper.LoadURLs(); //load bookmarked urls in array for faster retrieval
		Hyper.TopVisited(); //compute top visited bookmarks
	
		HypCommon.limitHistory(Hyper.histDS, prefs); //reduce history
	}
	catch (err) 
	{ 
		Hyper.dump.logStringMessage(err);
		Hyper.RepairDS(false); 	
	}
	
	HYExtraCommonWords();
	
	Hyper.dump.logStringMessage(HypCommon.getString("LOAD_OK"));
	
	/*if (prefs.getBoolPref("extensions.hyper.tempF") == false) //this block will be removed on the next version
	{
		prefs.setBoolPref("extensions.hyper.tempF", true);
		prefs.setIntPref("dom.max_script_run_time", 30); //due to improvements set to 30...
	}*/
}

function HY_Backup()
{
	var date = new Date();
	if ((date.getDate() % 5) != 0) return; //make backup every 5days or so...
	
	if (Math.floor(Math.random() * 20) > 13) return; //randomly there is no need to save on all times
	
	try
	{
		var s = HypCommon.dateToStr(new Date(), false);
		var bkfilen = "hyperBookmark" + s.replace(/\|/g, "_") + ".rdf";
				
		var origbkf = HypCommon.userHome("", "hyperBookmarks.rdf");
		var backbkdir = HypCommon.userHome("hyperBackup", "");
			
		var origFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var backDir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		
		origFile.initWithPath(origbkf);
		backDir.initWithPath(backbkdir);
		
		origFile.copyTo(backDir, bkfilen);
	}
	catch (err)
	{
	}
}

//First we make backup of Bookmark File
HY_Backup();

//call initialization
HY_Init();